#!/usr/local/bin/php
<?php
/*
 * Make makejpeg file from template.
 * $Id: mkmakejpeg.php,v 1.3 2011/02/19 01:42:38 grog Exp $
 */

/* Simulate mkdir -p */
function mkdir_p ($dir)
{
  if (! file_exists ($dir))
  {
    print "Creating $dir\n";
    mkdir ("$dir", 0755, 1);
  }
}

function perror ($text)
{
  $error = error_get_last ();
  $file = $error ['file'];
  $line = $error ['line'];
  $message = $error ['message'];

  if ($file)
    print "$text: $message, $file at line $line\n";
  else
    print "$text: $message at line $line\n";
  exit (1);
}

$template = fopen ("housephoto.def", "r");
if (! $template)
  exit (1);

$EV3 = array ("+0EV", "-1EV", "+1EV");
$EV5 = array ("+0EV", "-2EV", "-1EV", "+1EV", "+2EV");

while ($info = fscanf ($template,
                       "%s %s %s",
                       $photo,
                       $views,
                       $select ))
{
  if ($photo != "#")                            /* not a comment */
  {
    for ($view = 0; $view < $views; $view++)
    {
      $components = strlen ($select);
      /*
       * XXX we only cater for 1, 3 or 5 compoents.
       */
      if ($components == 3)
        $EV = $EV3;
      else
        $EV = $EV5;
/*      print "=== $photo $views\n"; */
      for ($image = 0; $image < $components; $image++)
      {
        if (substr ($select, $image, 1) == "*")
        {
          if ($components == 1)
            $myev = "";
          else
            $myev = $EV[$image];
          if ($views == 1)
            print "1 $photo$myev\n";
          else
            print "1 $photo-$view$myev\n";
        }
        else
          print "-\n";
      }
    }
  }
}

?>