#!/usr/local/bin/php
<?php
/*
 * Make 'tiny' and 'small' directories.
 * $Id: mktinysmall.php,v 1.2 2011/03/20 00:13:57 grog Exp $
 * This is called from the Makefile:
 *
 * mktinysmall tools dir webdir size pixelcount
 *
 * size is 'tiny' or 'small'
 * We don't need the source directory here.
 */

/* Simulate mkdir -p */
function mkdir_p ($dir)
{
  if (! file_exists ($dir))
  {
    print "Creating $dir\n";
    mkdir ("$dir", 0755, 1);
  }
}

/* Why can't I get user information or cwd from PHP? */
$home = system ("cd && pwd");
$tools = $argv [1];
$mydir = $argv [2];
$size = $argv [3];
$pixelcount = $argv [4];
$file = $argv [5];
$webdir = "$home/public_html/Photos/" . basename ($mydir);
if (0)
  print "$tools $mydir $size $pixelcount $file $webdir\n";
mkdir_p ("$webdir/$size");
chdir ("$webdir/big");
if (! file_exists ("../$size/$file"))
{
  $identity = explode (" ", system ("identify $file"));
  $imagesize = $identity [3];
  $horizpixels = preg_replace ("/x.*/", "", $imagesize);
  $vertpixels =  preg_replace ("/.*x/", "", $imagesize);
  $pixels = $vertpixels * $horizpixels;
  if (($pixels < $pixelcount) && ($identity [1] == "GIF"))
  {
    /* Don't convert small GIFs. */
    system ("ln  $file ../$size/$file");
    print "Linked $file unchanged";
  }
  else                                          /* convert it */
  {
    $mywidth = $horizpixels * sqrt ($pixelcount / $pixels);
    if (0)
      printf ("imagesize: $imagesize\nhorizpixels: $horizpixels\nvertpixels: $vertpixels\npixels: $pixels\nmywidth: $mywidth\n");
    $etime = explode (" ",
                      preg_replace ("/ +/",
                                    " ",
                                    system ("time convert -interlace line -geometry $mywidth $file ../$size/$file 2>&1") ) );
    print "Converted $size/$file ($etime[1] seconds)";
  }
}
else
  echo "$size/$file exists already\n";
?>