<!-- $Id: Photos.php,v 1.53 2012/06/03 04:13:56 grog Exp $ -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<?php
  include "header.php";

  $doedit = "Edit description";                 /* magic string to turn editing on */
  $nogo = 0;                                    /* set if we have to exit early */
  if (array_key_exists ("size", $_GET))
    $size = $_GET ["size"];
  else
    $size = "1";
  $edit = 0;
  if ((array_key_exists ("edit", $_GET))
      && ($_GET ["edit"] == $doedit) )
    $edit = "1";                                /* to propagate to other pages */

  /* XXX for hysterical raisins we're passing a dirdate, but it's not what we want */
  if (array_key_exists ("dirdate", $_GET))
    {
    $photodate = validdate ($_GET ["dirdate"], "date");
    /*
     * Now set start and end dates 10 days either way so we can link to an
     * appropriate range in header and footer.
     */
    $default_days = 10;
    $startdate = formatdate ("Ymd", (addsecs ($photodate, -86400 * $default_days)));
    $enddate = formatdate ("Ymd", (addsecs ($photodate, 86400 * $default_days)));
    }
  else
    {
    print <<< EOS
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="REFRESH" content="15;url=photos.php" />
  </head>

  <body>
    <font color="red">This page is intended to be used with parameters passed from other pages, in
    particular the <tt>dirdate</tt> parameter which specifies the date in the format YYYYMMDD.
    Either you have removed the parameters or mutilated the URL.  Did you get this URL from a broken
    mail system?  Without this information, the page cannot display anything useful.  You will soon
    be redirected to the photo index.  Please select a date from the list there.
  </body>
</html>

EOS;
      exit ();
      }

  /* Handle editing descriptions. */
  if (($_SERVER ["HTTP_HOST"] == "wwww.lemis.com")
      && $edit
      && (array_key_exists ("desc", $_POST)) )
  {
    $desc = $_POST ["desc"];
    $descfile = $_POST ["filename"];
    if ($desc == "")
    {
      if (file_exists ($descfile))
        unlink ($descfile);
    }
    else
    {
      file_put_contents ($descfile, $desc);
      chmod ($descfile, 0664);
    }
  }

  $dirdate = formatdate ("Ymd", $photodate);    /* YYYYMMDD form of start date */
  $day = formatdate ("j", $photodate);          /* Wednesday, 8 July 2009 */
  $month = strtolower (formatdate ("M", $photodate)); /* 8 Jul 2009 */
  $year = formatdate ("Y", $photodate);
  $realdate = formatdate ("l, j F Y", $photodate);
  $titledate = formatdate ("j M Y", $photodate);
  /* File and URL of corresponding diary entry */
  $diary = "../diary-$month$year.php";
  if (file_exists ($diary))
  {
    $diaryentry = "$diary#$day";

    /* URL of corresponding diary entry */
    $diary = "/$who/diary-$month$year.php#$day";
  }
  else
    $diary = "";                               /* No diary entry for this month */
  $description = photo_description ($dirdate);
  if (array_key_exists ("current",  $description))
    $subtitle = $description ["current"] [1];
  else
    $subtitle = "";
  $title = "$whoname's photos: $realdate";
  $id = '$Id: Photos.php,v 1.53 2012/06/03 04:13:56 grog Exp $';
?>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <?php pagetitle0 ("$whoname's photos, $titledate: $subtitle"); ?>
  </head>

  <body>
    <?php pageheader0 ($title); ?>

<?php

  $mydir = "../Photos/$dirdate";
  $descfile = "$mydir/heading";
  $photolist = "$mydir/photolist.php";
  if (! file_exists ($photolist))
    {
    print <<< EOS
    <p>
      <font color="red">
        No photos are available for $realdate.  Please select another date.
      </font>
    </p>

EOS;
    $nogo = 1;
  }
  else
    $photos = fopen ($photolist, "r");

  $tempdate = formatdate ("j F Y", $photodate);
  print <<< EOS
    <form action="Photos.php" method="get">
      <table summary="Parameter input" cellspacing="2" border="0" width="100%">
        <tr>
          <td><input type="submit" value="Select new date: "/>
          <!-- value -->
          <input size="20" maxlength="20" type="text" name="dirdate"
            value="$tempdate" />

EOS;
  if ((isset ($startdate) && isset ($enddate))
       && (gettype ($startdate) == "string") )
     print "
        <a href=\"photos.php?startdate=$startdate&amp;enddate=$enddate\">or index of photos round this date</a>\n";
     else
	print "
        <a href=\"photo-index.php\">or photo index</a>\n";
  print <<<EOS
          </td>

          <td align="right">
            <a href="/$who/photos/Onephoto.php?dirdate=$dirdate&amp;size=2">Individual photos</a>
          </td>
        </tr>

EOS;
  if ((array_key_exists ("prev",  $description))
    || (array_key_exists ("next",  $description)) )
    {
      print <<<EOS
        <tr>
          <td>

EOS;
      if (array_key_exists ("prev",  $description))
        {
          $tempdir = $description ["prev"] [0];
          $tempdate = validdate ($tempdir, "date");
          $tempdate = formatdate ("j M Y", $tempdate);
          $desc = $description ["prev"] [1];
       print <<<EOS
            <a href="Photos.php?dirdate=$tempdir">Previous ($tempdate): $desc</a>

EOS;
        }
      else
        print <<<EOS
            (no prior entries)

EOS;
       print <<<EOS
          </td>
          <td align="right">

EOS;
      if (array_key_exists ("next",  $description))
        {
          $tempdir = $description ["next"] [0];
          $tempdate = validdate ($tempdir, "date");
          $tempdate = formatdate ("j M Y", $tempdate);
          $desc = $description ["next"] [1];
       print <<<EOS
            <a href="Photos.php?dirdate=$tempdir">Next ($tempdate): $desc</a>

EOS;
        }
      else
        print <<<EOS
            (no further entries)

EOS;
       print <<<EOS
          </td>
        </tr>

EOS;
    }
  print <<<EOS
      </table>
    </form>
EOS;

  if ($nogo)
  {
  include "footing.php";

  print <<< EOS
  </body>
</html>
EOS;
  exit (0);
  }

   switch ($size)
     {
   case "1":
     if ($who == "grog")
     {
       print <<< EOS

    <p align="justify">
      These images are thumbnails (well, smaller versions) of all the photos taken on or slightly
      before $realdate.  They're sorted by time of exposure.  The purpose of this page is rather
      like the contact prints that used to be used in the film days: they give me an overview of all
      photos taken on the day.  Unlike contact prints, I have removed images that are completely
      useless, but I've kept anything that might be in any way usable.  There's no implication that
      their presence here means that I think they're good.  In addition, there may be no
      relationship between the individual images.
    </p>

     <p>
       Click on any image to display a larger version
EOS;

       if ($diary != "")
         print ', or read the <a href="' . $diary . '">diary entry</a> corresponding to the day';
     print <<< EOS
.
   </p>

EOS;
     }
     else
       print <<< EOS

    <p>
      These images are thumbnails of photos taken on or slightly before
      $realdate.  Click on any image to display a larger version.
    </p>

EOS;
     break;

   default:
     if ($who == "grog")
     {
       print <<< EOS

    <p align="justify">
      This page contains all the photos taken on or slightly before $realdate.  They're sorted by
      time of exposure.  The purpose of this page is rather like the contact prints that used to be
      used in the film days: they give me an overview of all photos taken on the day.  Unlike
      contact prints, I have removed images that are completely useless, but I've kept anything that
      might be in any way usable.  There's no implication that their presence here means that I
      think they're good.  In addition, there may be no relationship between the individual images.
    </p>

     <p>
       Click on any image to display a larger version
EOS;

       if ($diary != "")
         print ', or read the <a href="' . $diary . '">diary entry</a> corresponding to the day';
     print <<< EOS
.
   </p>

    <p>
      The photos on this page have been set to a uniform &ldquo;small&rdquo; size that is usually
      smaller then the originals; to see the originals, click on the photo in question with the
      mouse.  See the <a href="index.php#hires">overview page</a> for more details.
    </p>
EOS;
      }
    else
      print <<< EOS

    <p>
      The photos on this page have been set to a uniform &ldquo;small&rdquo; size that is usually
      smaller then the originals; to see the originals, click on the photo in question with the
      mouse.
    </p>
EOS;
    }

  if ($oldimagesizes != $imagesizes)
  {
    $urls = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['SCRIPT_NAME'] . "?imagesizes=";
    $oldurl = $urls . $oldimagesizes . "&amp;dirdate=$dirdate";
    $newurl = $urls . $imagesizes . "&amp;dirdate=$dirdate";
//    print "<pre>";
//    print_r ($_SERVER);
    print <<< EOS
      <blockquote>
	<p>
	  <font color="red">
	    The URL you gave (<font color="blue">$oldurl</font>) is no longer valid.  If you have
	    bookmarked it, please replace with the new URL <a href="$newurl">$newurl</a>.
	  </font>
	</p>
      </blockquote>

EOS;
  }
  /* Offer to edit if we're at home */
  if (islocal ())
  {
    if ($edit)
       /* cancel edit */
      print <<< EOS
    <form action="Photos.php" method="get">
      <input type="hidden" name="size" value="$size" />
      <input type="hidden" name="imagesizes" value="$imagesizes" />
      <input type="hidden" name="dirdate" value="$dirdate" />
      <input type="submit" name="edit" value="Cancel edit" />
    </form>
    <br />
EOS;
    else                                        /* set edit */
      print <<< EOS
    <form action="Photos.php" method="get">
      <input type="hidden" name="size" value="$size" />
      <input type="hidden" name="imagesizes" value="$imagesizes" />
      <input type="hidden" name="dirdate" value="$dirdate" />
      <input type="submit" name="edit" value="$doedit" />
    </form>
    <br />
EOS;
  }

  if (file_exists ("$mydir/Pano"))
    print <<< EOS
      <p>
      This page contains <a href="$mydir/Pano/">panoramas</a> animated with
      <a href="http://panozona.com/wiki/SaladoPlayer">SaladoPlayer</a>
      </p>
EOS;
    if (file_exists ("$descfile"))
      print '
    <hr/>

    <p>
' . file_get_contents ("$descfile") . '
    <p>';
   while ($info = fscanf ($photos,
                          "%s %s %s %s %s %s %s %s %s %s\n",
                          $photo,
                          $tinywidth,
                          $tinyheight,
                          $tinykb,
                          $smallwidth,
                          $smallheight,
                          $smallkb,
                          $bigwidth,
                          $bigheight,
                          $bigkb ))
   {
     if (substr ($photo, 0, 1) == "%")             /* video */
     {
       $photo = substr ($photo, 1);             /* this is the name */

       youtube ($tinywidth);                    /* this is the YouTube ID */
     }
     else
     {
       $descfile = "$mydir/" . basename ($photo, ".jpeg") . ".desc";
       /*
        * Decide whether we want to display a description.
        * This is quite a decision.  For the time being, just do it.  XXX
        */
/*    if ($size != "1") */
       {
         /*
          * If we have a description of a tiny file, make sure it's on its own line.
          */
         if ($size == "1"
             && file_exists ($descfile) )
           print <<< EOS
    <br />

EOS;
         showphoto ("/$who/Photos/$dirdate/$photo");
         if (file_exists ($descfile))
           print '
    <p>
' . file_get_contents ($descfile) . '
    <p>
    <hr/>

';
       }
       /* Handle editing descriptions */
       if (islocal () && $edit )
       {
         if (file_exists ($descfile))
           $descr = file_get_contents ($descfile);
         else
           $descr = "";
         print <<< EOS
    <form action="Photos.php?size=$size&dirdate=$dirdate&amp;edit=$doedit" method="post">
        <input type="submit" value="Enter description: "/>
        <input size="128" type="hidden" name="filename" value="$descfile" />
        <input size="120" maxlength="1024" type="text" name="desc"
               value="$descr" />
    </form>

EOS;
       }
     }
   }

  fclose ($photos);
  if ((array_key_exists ("prev",  $description))
      || (array_key_exists ("next",  $description)) )
  {
    print <<<EOS
      <table summary="" cellspacing="2" border="0" width="100%">
        <tr>
          <td>

EOS;
    if (array_key_exists ("prev",  $description))
    {
      $tempdir = $description ["prev"] [0];
      $tempdate = validdate ($tempdir, "date");
      $tempdate = formatdate ("j M Y", $tempdate);
      $desc = $description ["prev"] [1];
      print <<<EOS
            <a href="Photos.php?dirdate=$tempdir">Previous ($tempdate): $desc</a>

EOS;
    }
    else
      print <<<EOS
            (no prior entries)

EOS;
    print <<<EOS
          </td>
          <td align="right">

EOS;
    if (array_key_exists ("next",  $description))
    {
      $tempdir = $description ["next"] [0];
      $tempdate = validdate ($tempdir, "date");
      $tempdate = formatdate ("j M Y", $tempdate);
      $desc = $description ["next"] [1];
      print <<<EOS
        <a href="Photos.php?dirdate=$tempdir">Next ($tempdate): $desc</a>

EOS;
    }
    else
      print <<<EOS
            (no further entries)

EOS;
    print <<<EOS
          </td>
        </tr>

EOS;
  }
  print <<<EOS
      </table>

EOS;
  include "footing.php" ?>
