<!-- Hey, emacs!  Edit this file in -*- html-fill -*- mode! -->
<!-- $Id: photos.php,v 2.54 2012/04/29 00:25:08 grog Exp $ -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<?php
   include "header.php";

$default_days = 20;                             /* number of days to display by default */
$startdate = "";
$enddate = "";
if (array_key_exists ("keywords",  $_GET))
  $keywords = $_GET ["keywords"];
else
{
  $keywords = "";
  if (array_key_exists ("startdate", $_GET))
  {
    $date = $_GET ["startdate"];
    if ($date != "")
      /*
       * We don't handle the case of the unspecified start date yet.  That comes
       * after the end date processing.
       */
    {
      $startdate = validdate ($date, "date");
      if (is_string ($startdate))                 /* error */
      {
        /* this is the error message */
        print '<p><font color="red">' . $startdate . '</font></p>';
        $startdate = "";                          /* don't use it yet */
      }
    }
  }
  if (array_key_exists ("enddate", $_GET))
  {
    $date = $_GET ["enddate"];
    if ($date != "")
    {
      $enddate = validdate ($date, "date");
      if (is_string ($enddate))                   /* error */
      {
        print $enddate;
        $enddate = "";                            /* and reset */
      }
    }
  }
}
/*
 * Now we have either keywords, valid start and end dates, or empty ones.  If we
 * have keywords, we ignore the dates.  Otherwise decide what to fill in, and
 * how.
 */

$title = "$whoname's photos";
$id = '$Id: photos.php,v 2.54 2012/04/29 00:25:08 grog Exp $';
$diary = "";                                    /* to suppress heading */
if ($keywords == "")
{
  if ($startdate == "")                           /* no start, */
  {
    if ($enddate == "")                           /* and no end */
      $enddate = getdate ();                      /* end defaults to today */
    $startdate = addsecs ($enddate, -86400 * $default_days); /* either way, start default days earlier */
  }
  else if ($enddate == "")                        /* a month later than start date */
    $enddate = addsecs ($startdate, 86400 * $default_days);  /* default days later */

  if ($startdate [0] > $enddate [0])              /* Negative time interval, */
    $enddate = $startdate;                        /* just one day, startdate */
  $startdir = formatdate ("Ymd", $startdate);     /* YYYYMMDD form of start date */
  $enddir = formatdate ("Ymd", $enddate);         /* YYYYMMDD form of end date */
  $realstartdate = formatdate ("l, j F Y", $startdate); /* and long forms */
  $realenddate = formatdate ("l, j F Y", $enddate);
  $subtitle = formatdate ("j F Y", $startdate) .  " to " .  formatdate ("j F Y", $enddate);
  $sd = formatdate ("j F Y", $startdate);
  $ed = formatdate ("j F Y", $enddate);
  $prevdate = addsecs ($startdate, -86400 * $default_days);
  $prevd = formatdate ("j F Y", $prevdate);
  $nextdate = addsecs ($enddate, 86400 * $default_days);
  $nextd = formatdate ("j F Y", $nextdate);
  $startdate_formatted =  formatdate ("j F Y", $startdate);
  $enddate_formatted = formatdate ("j F Y", $enddate);
}
else                                            /* keywords */
{
  $sd = "";
  $ed = "";
  $subtitle = "Keyword search: $keywords";
}

?>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <?php pagetitle0 ($title); ?>
  </head>

  <body>
    <?php pageheader0 ($title); ?>

<?php
print <<< EOS
    <form action="$me" method="get">
      <table summary="Parameter input" cellspacing="2" border="0">
        <tr>

EOS;


   print <<< EOS
	  <!-- Start and end date -->
          <td>
	    <input type="submit" value="Select new dates: "/>
	  </td>
          <!-- start date -->
          <td>
	    &nbsp;Start date:
	  </td>
          <!-- value -->
          <td>
  	    <input size="20" maxlength="20" type="text" name="startdate" value="$sd" />
	  <td>
            <!-- end date -->
          <td>&nbsp;End date:</td>
          <!-- value -->
          <td>
	    <input size="20" maxlength="20" type="text" name="enddate" value="$ed" />
	  <td>
        </tr>
      </table>
    </form>

    <!-- Specific date -->
    <table summary="Parameter input" cellspacing="2" border="0">
      <tr>
	<form action="Photos.php" method="get">
          <td>
	    <input type="submit" value="Or select specific date:"/>
	  </td>

	  <td>
	     &nbsp;&nbsp;&nbsp;&nbsp;&nbsp&nbsp;&nbsp;&nbsp;&nbsp
	  </td>

          <!-- value -->
          <td>
  	    <input size="20" maxlength="20" type="text" name="dirdate" />
	  </td>
	</form>

EOS;
   if ($who == "grog")
     print <<< EOS

          <td>
	    <a href="photo-index.php">or go to index</a>
	  </td>
EOS;
   print <<< EOS
        </tr>
      </table>

    <!-- Keyword search -->
    <table summary="Parameter input" cellspacing="2" border="0">
      <tr>
	<form action="$me" method="get">
          <td>
	    <input type="submit" value="Search keywords in description:"/>
<!--  	    <input size="20" maxlength="20" type="hidden" name="startdate" value="$sd"/>
            <input size="20" maxlength="20" type="hidden" name="enddate" value="$ed"/> -->
	  </td>

	  <td>
	     &nbsp;&nbsp;&nbsp;&nbsp;&nbsp&nbsp;&nbsp;&nbsp;&nbsp
	  </td>

          <!-- value -->
          <td>
  	    <input size="20" maxlength="20" type="text" value="$keywords" name="keywords" />
	  </td>
        </form>

	<!-- search photo titles -->
	<form action="photosearch.php" method="get">
          <td>
	    <input type="submit" value="Search photo titles:"/>
<!--  	    <input size="20" maxlength="20" type="hidden" name="startdate" value="$sd"/>
            <input size="20" maxlength="20" type="hidden" name="enddate" value="$ed"/> -->
	  </td>

	  <td>
	     &nbsp;&nbsp;&nbsp;&nbsp;&nbsp&nbsp;&nbsp;&nbsp;&nbsp
	  </td>

          <!-- value -->
          <td>
  	    <input size="20" maxlength="20" type="text" value="$keywords" name="keywords" />
	  </td>
        </form>
</tr>
</table>
EOS;

  if ($keywords == "")
    print <<< EOS
    <table width="100%">
      <tr>
	<td align="left">
          <!-- previous 20 days -->
          <form action="photos.php" method="get">
	        <input type="submit" value="Previous period ($prevd to $sd)"/>
  	        <input size="20" maxlength="20" type="hidden" name="startdate" value="$prevd"/>
                <input size="20" maxlength="20" type="hidden" name="enddate" value="$sd"/>
          </form>
	</td>

	<td align="right">
           <!-- previous 20 days -->
           <form action="photos.php" method="get">
	         <input type="submit" value="Following period ($ed to $nextd)"/>
  	         <input size="20" maxlength="20" type="hidden" name="startdate" value="$ed"/>
  	         <input size="20" maxlength="20" type="hidden" name="enddate" value="$nextd"/>
           </form>
	</td>
      </tr>
    </table>

EOS;
?>
    <p />

    <table summary="List of photo directories" cellspacing="2" border="2" width="100%">
      <?php
          /* dirlist has the format 'directory name', 'description' */
         $photos = fopen ("dirlist", "r");
         $dirhits = 0;
         while ($line = fgets ($photos))
         {
           $info = explode (" ", $line, 2);      /* make two parts */
           /* extract the parameters from the photo list */
           $dirdate = $info [0];

           if ($keywords == "")
             /* The upper limit is a primitive protection against data corruption */
             $found =  $dirdate >= $startdir && $dirdate <= $enddir;
           else
           {
             $found = 0;
             $keys = explode (" ", $keywords);
             foreach ($keys as $keyword)
             {
               if ($found = stristr ($info [1], $keyword))
               {
                 $found = 1;
                 break;
               }
             }
           }
           if ($found)
           {
             $dirhits++;
             /* and convert to a printable date */
             $photodate = validdate ($dirdate, "date");
             $realdate = formatdate ("l, j F Y", $photodate);
             $description = $info [1];   /* descriptive text */

             print <<< EOS

      <tr>
        <td>$realdate</td>
        <td><a href="/$who/photos/Photos.php?size=2&amp;dirdate=$dirdate">$description</a></td>
        <td><a href="/$who/photos/Photos.php?dirdate=$dirdate">Thumbnails</a></td>
        <td><a href="/$who/photos/Onephoto.php?size=2&amp;dirdate=$dirdate">Individual photos</a></td>
EOS;
	if ($who == "grog")
          {
	$diary = diaryname ($dirdate, $who);
          print '
        <td align="right">';
               print "<a href=\"$diary\">diary</a>";
            print '</td>
      </tr>';
          }
              }
            }
          print '
    </table>' . "\n";

  if ($keywords == "")
    print <<< EOS

    <table width="100%">
      <tr>
	<td align="left">
          <!-- previous 20 days -->
          <form action="photos.php" method="get">
	        <input type="submit" value="Previous period ($prevd to $sd)"/>
  	        <input size="20" maxlength="20" type="hidden" name="startdate" value="$prevd"/>
                <input size="20" maxlength="20" type="hidden" name="enddate" value="$sd"/>
          </form>
	</td>

	<td align="right">
           <!-- previous 20 days -->
           <form action="photos.php" method="get">
	         <input type="submit" value="Following period ($ed to $nextd)"/>
  	         <input size="20" maxlength="20" type="hidden" name="startdate" value="$ed"/>
  	         <input size="20" maxlength="20" type="hidden" name="enddate" value="$nextd"/>
           </form>
	</td>
      </tr>
    </table>

EOS;

if ($who == "grog")
{
  print <<< EOS

    <p>
    I&apos;ve been collecting photos on line since 1998.
EOS;

  if ($keywords == "")
  print <<< EOS
      These are from the period $startdate_formatted
      to $enddate_formatted.  See the <a href="photo-index.php">index</a> for others, or enter a date
      range below in just about any format (except for US out-of-order numbering, which conflicts with
      other forms), including text like &ldquo;today&rdquo; and &ldquo;yesterday&rdquo; (or even
      &ldquo;tomorrow&rdquo;, for what good that will do).  You can leave start or end date out and
      it'll give you a $default_days day range.  Let me know if you find a date format which it can't
      handle.
EOS;
  else
  {
    print <<< EOS
      This view shows those headings which contain at least one of the keywords &ldquo;$keywords&rdquo;
      (case insensitive).

EOS;
    if ($dirhits == 0)
      print <<< EOS
        Unfortunately, there are no headings that match the search.  That doesn't mean that there
        are no photos, only that there are no headings with any of the search terms.

EOS;
  }
  print <<< EOS
    </p>

    <p>
      This view of the photos is in a directory relating to the day.  These are more a chronology of
      events than a useful description; the more useful links are mainly from my diary.  In most cases
      you should get more information from my diary for the day or a couple of days earlier.  There
      are some more structured views of the same collection of photos in
      my <a href="../Albums/">Albums</a>.
    </p>

EOS;
}

    include "footing.php" ?>
