<!-- Hey, emacs!  Edit this file in -*- html-fill -*- mode! -->
<!-- $Id: photosearch.php,v 1.8 2012/04/05 04:36:49 grog Exp $ -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<?php
   include "header.php";

$default_days = 20;                             /* number of days to display by default */
$defaultstart = "19000000";                     /* limit dates to numerical dates */
$startdate = $defaultstart;                     /* limit dates to numerical dates */
$defaultend = "21000000";
if (islocal ())
   $maximages = 20000;                           /* maximum number of images to show */
else
   $maximages = 200;                            /* maximum number of images to show */
$enddate = $defaultend;
if (array_key_exists ("keywords",  $_GET))
  $keywords = $_GET ["keywords"];
else
  $keywords = "";
if (array_key_exists ("startdate", $_GET))
{
  $date = $_GET ["startdate"];
  if ($date != "")
    /*
     * We don't handle the case of the unspecified start date yet.  That comes
     * after the end date processing.
     */
  {
    $startdate = validdate ($date, "date");
    if (is_string ($startdate))                 /* error */
    {
      /* this is the error message */
      print '<p><font color="red">' . $startdate . '</font></p>';
      $startdate = "";                          /* don't use it yet */
    }
  }
}
if (array_key_exists ("enddate", $_GET))
{
  $date = $_GET ["enddate"];
  if ($date != "")
  {
    $enddate = validdate ($date, "date");
    if (is_string ($enddate))                   /* error */
    {
      print $enddate;
      $enddate = "";                            /* and reset */
    }
  }
}
if (array_key_exists ("maximages", $_GET))
  $maximages = $_GET ["maximages"];

$title = "$whoname's photo album";
$id = '$Id: photosearch.php,v 1.8 2012/04/05 04:36:49 grog Exp $';
$diary = "";                                    /* to suppress heading */
if ($startdate == "")                           /* no start, */
{
  if ($enddate == "")                           /* and no end */
    $enddate = getdate ();                      /* end defaults to today */
  $startdate = addsecs ($enddate, -86400 * $default_days); /* either way, start default days earlier */
}
else if ($enddate == "")                        /* a month later than start date */
  $enddate = addsecs ($startdate, 86400 * $default_days); /* default days later */

if ($startdate [0] > $enddate [0])              /* Negative time interval, */
  $enddate = $startdate;                        /* just one day, startdate */
$startdir = formatdate ("Ymd", $startdate);     /* YYYYMMDD form of start date */
$enddir = formatdate ("Ymd", $enddate);         /* YYYYMMDD form of end date */
$realstartdate = formatdate ("l, j F Y", $startdate); /* and long forms */
$realenddate = formatdate ("l, j F Y", $enddate);
if ($startdate == $defaultstart)                /* limit dates to numerical dates */
  $sd = "";
else
  $sd = formatdate ("j F Y", $startdate);
if ($enddate == $defaultend)
  $ed = "";
else
  $ed = formatdate ("j F Y", $enddate);
$subtitle = "Keywords: $keywords";
if ($sd != "" && $ed != "")
  $subtitle .= formatdate ("j F Y", $startdate) .  " to " .  formatdate ("j F Y", $enddate);
$prevdate = addsecs ($startdate, -86400 * $default_days);
$prevd = formatdate ("j F Y", $prevdate);
$nextdate = addsecs ($enddate, 86400 * $default_days);
$nextd = formatdate ("j F Y", $nextdate);
$startdate_formatted =  formatdate ("j F Y", $startdate);
$enddate_formatted = formatdate ("j F Y", $enddate);

?>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <?php pagetitle0 ($title); ?>
  </head>

  <body>
    <?php pageheader0 ($title); ?>

<?php
print <<< EOS
    <form action="$me" method="get">
      <table summary="Parameter input" cellspacing="2" border="0">
        <tr>

EOS;


   print <<< EOS
	  <!-- Start and end date -->
          <td>
	    <input type="submit" value="Select new dates: "/>
	  </td>
          <!-- start date -->
          <td>
	    &nbsp;Start date:
	  </td>
          <!-- value -->
          <td>
  	    <input size="20" maxlength="20" type="text" name="startdate" value="$sd" />
	  <td>
            <!-- end date -->
          <td>&nbsp;End date:</td>
          <!-- value -->
          <td>
	    <input size="20" maxlength="20" type="text" name="enddate" value="$ed" />
	  <td>
        </tr>
      </table>
    </form>

    <!-- Specific date -->
    <table summary="Parameter input" cellspacing="2" border="0">
      <tr>
	<form action="$me" method="get">
          <td>
	    <input type="submit" value="Or select keywords:"/>
	  </td>

	  <td>
	     &nbsp;&nbsp;&nbsp;&nbsp;&nbsp&nbsp;&nbsp;&nbsp;&nbsp
	  </td>

          <!-- value -->
          <td>
  	    <input size="20" maxlength="20" type="text" value="$keywords" name="keywords" />
	  </td>
        </tr>
      </table>
    </form>

EOS;
?>
    <p class="fullwidth" />

    <?php
    if ($keywords != "")
    {
      $photocount = 0;
      $photodir = "$homedir/Photos";
      $dirs = scandir ($photodir);
      if (islocal ())                           /* make a temp web page to access the photos */
      {
        $temppage = fopen ("$photodir/../tmp/photos.php", "w");
        fprintf ($temppage, <<< EOS
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<?php
   include "header.php";
   \$id = '$id';
   \$title = "%s"; ?>
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <?php pagetitle0 (\$title); ?>
  </head>

  <body>
    <?php
  pageheader0 (\$title);

EOS
        , $title);
      }
      foreach ($dirs as $dir)
      {
        if (($dir >= $startdate)
            && ($dir <= $enddate)
            && (file_exists ("$photodir/$dir/photolist.php")) )
        {
          /* photolist.php has the format 'image name', dimensions' */
          $photos = fopen ("$photodir/$dir/photolist.php", "r");
          $dirhits = 0;
          $urldir = "Photos/$dir";
          $found = 0;
          while ($line = fgets ($photos))
          {
            $info = explode (" ", $line, 2);    /* make two parts */
            /* extract the parameters from the photo list */
            $keys = explode (" ", $keywords);
            foreach ($keys as $keyword)
            {
              if (stristr ($info [0], $keyword))
              {
                if (! $found)                 /* first image for this date */
                {
                  /*
                   * shortdaytitle would be good here, but we end up on no-mans-land.
                   */
                  dayhdr ($dir);
                  if (islocal ())                 /* make a temp web page to access the photos */
                    fprintf ($temppage, <<< EOS

  dayhdr (%s);
  showdetailbutton ();

EOS
                             , $dir);
                }
                if (islocal ())
                  fprintf ($temppage, "  showphoto (\"/%s/%s/%s\");\n", $who, $urldir, $info [0]);
                $found = 1;
                showphoto ("$urldir/" . $info [0]);
                if (++$photocount == $maximages)
                {
                  print <<< EOS
      <p>
        These are the first $maximages photos which match.  To see more, please refine your search terms.
      </p>
EOS;
                  include "../photos/footing.php";
                  exit;
                }
                break;
              }
            }
          }
        }
      }
    }
    else
      print <<< EOS
        <p>
          This page allows you to define your own &ldquo;album&rdquo;.  Fill out the fields above
          with search terms and optionally with start and end dates.  The search term will match any
          part of a photo title, and if you enter more than one term, it will match any of them.
          The search is case-independent.  For example, &ldquo;Chris&rdquo; will match
          &ldquo;Christmas&rdquo;, and &ldquo;Rose&rdquo; will match &ldquo;rosella&rdquo;.
	</p>

	<p>
	  This is still experimental, and it's not guaranteed to find everything.  Particularly my
	  older photos don't have sensible names, and I don't currently intend to change that.  I
	  also limit the number of hits to $maximages, and I don't currently have a good way to find
	  the rest.
	</p>
EOS;
    if (islocal ())
      fprintf ($temppage, "\n  include \"../photos/footing.php\"\n?>");
    include "../photos/footing.php" ?>
