<?php
/*
 * Time and date functions.
 *
 * From Black Box project
 * $BBId: datefuncs.php,v 1.6 2006/12/13 02:49:53 grog Exp $
 * $Id: datefuncs.php,v 1.20 2012/07/09 02:31:38 grog Exp $
 */

date_default_timezone_set ("Australia/Melbourne");

/* These used to be in defs.php */
/* Month names in two different formats, just to make PHP happy. */
$monthname = array (1 => "January",
                    2 => "February",
                    3 => "March",
                    4 => "April",
                    5 => "May",
                    6 => "June",
                    7 => "July",
                    8 => "August",
                    9 => "September",
                    "01" => "January",
                    "02" => "February",
                    "03" => "March",
                    "04" => "April",
                    "05" => "May",
                    "06" => "June",
                    "07" => "July",
                    "08" => "August",
                    "09" => "September",
                    "10" => "October",
                    "11" => "November",
                    "12" => "December");

$monthabbr = array ("1" => "jan",
                    "2" => "feb",
                    "3" => "mar",
                    "4" => "apr",
                    "5" => "may",
                    "6" => "jun",
                    "7" => "jul",
                    "8" => "aug",
                    "9" => "sep",
                    "01" => "jan",
                    "02" => "feb",
                    "03" => "mar",
                    "04" => "apr",
                    "05" => "may",
                    "06" => "jun",
                    "07" => "jul",
                    "08" => "aug",
                    "09" => "sep",
                    "10" => "oct",
                    "11" => "nov",
                    "12" => "dec");

/* Ugh */
$monthstring = array (1 => "01",
                      2 => "02",
                      3 => "03",
                      4 => "04",
                      5 => "05",
                      6 => "06",
                      7 => "07",
                      8 => "08",
                      9 => "09",
                      10 => "10",
                      11 => "11",
                      12 => "12" );
/*
 * Diary stuff.  This used to be in diaryheader.php, then in header.php.
 */

$monthinfo = array ("jan" => array ("Name" => "January",
                                    "days" => 31,
                                    "prev" => "dec",
                                    "next" => "feb"),
                    "feb" => array ("Name" => "February",
                                    "days" => 29,
                                    "prev" => "jan",
                                    "next" => "mar"),
                    "mar" => array ("Name" => "March",
                                    "days" => 31,
                                    "prev" => "feb",
                                    "next" => "apr"),
                    "apr" => array ("Name" => "April",
                                    "days" => 30,
                                    "prev" => "mar",
                                    "next" => "may"),
                    "may" => array ("Name" => "May",
                                    "days" => 31,
                                    "prev" => "apr",
                                    "next" => "jun"),
                    "jun" => array ("Name" => "June",
                                    "days" => 30,
                                    "prev" => "may",
                                    "next" => "jul"),
                    "jul" => array ("Name" => "July",
                                    "days" => 31,
                                    "prev" => "jun",
                                    "next" => "aug"),
                    "aug" => array ("Name" => "August",
                                    "days" => 31,
                                    "prev" => "jul",
                                    "next" => "sep"),
                    "sep" => array ("Name" => "September",
                                    "days" => 30,
                                    "prev" => "aug",
                                    "next" => "oct"),
                    "oct" => array ("Name" => "October",
                                    "days" => 31,
                                    "prev" => "sep",
                                    "next" => "nov"),
                    "nov" => array ("Name" => "November",
                                    "days" => 30,
                                    "prev" => "oct",
                                    "next" => "dec"),
                    "dec" => array ("Name" => "December",
                                    "days" => 31,
                                    "prev" => "nov",
                                    "next" => "jan"),
                    "01" => array ("Name" => "January",
                                    "days" => 31,
                                    "prev" => "dec",
                                    "next" => "feb"),
                    "02" => array ("Name" => "February",
                                    "days" => 29,
                                    "prev" => "jan",
                                    "next" => "mar"),
                    "03" => array ("Name" => "March",
                                    "days" => 31,
                                    "prev" => "feb",
                                    "next" => "apr"),
                    "04" => array ("Name" => "April",
                                    "days" => 30,
                                    "prev" => "mar",
                                    "next" => "may"),
                    "05" => array ("Name" => "May",
                                    "days" => 31,
                                    "prev" => "apr",
                                    "next" => "jun"),
                    "06" => array ("Name" => "June",
                                    "days" => 30,
                                    "prev" => "may",
                                    "next" => "jul"),
                    "07" => array ("Name" => "July",
                                    "days" => 31,
                                    "prev" => "jun",
                                    "next" => "aug"),
                    "08" => array ("Name" => "August",
                                    "days" => 31,
                                    "prev" => "jul",
                                    "next" => "sep"),
                    "09" => array ("Name" => "September",
                                    "days" => 30,
                                    "prev" => "aug",
                                    "next" => "oct"),
                    "10" => array ("Name" => "October",
                                    "days" => 31,
                                    "prev" => "sep",
                                    "next" => "nov"),
                    "11" => array ("Name" => "November",
                                    "days" => 30,
                                    "prev" => "oct",
                                    "next" => "dec"),
                    "12" => array ("Name" => "December",
                                    "days" => 31,
                                    "prev" => "nov",
                                    "next" => "jan") );

/*
 * Validate a date or time.  Returns an array (getdate style) or error message.
 *
 * $date is a date or time string in most formats.  1/2/2006 means 1 February,
 * not 2 January.
 *
 * $type is null, "date", or "time".
 * If "date", validation fails if the string contains a time component.
 * If "time", validation fails if the string contains a date component.
 * If empty, validation fails only if the combination is invalid.
 *
 */

function validdate ($date, $type)
{
  $now = getdate ();
  if (strlen ($date) > 0)
  {
    /*
     * What a crock!  PHP's time parsing functions assume US American broken
     * dates if you specify something like 26/10/2006, though most of the world
     * parses these numbers differently.  For this case only, turn the numbers
     * around into US American format (i.e. 10/26/2006).
     */
    $newdate = preg_replace ('|([0-9]+)/([0-9]+)/([0-9]+)|',
                             '\2/\1/\3',
                             $date );

    /* Reformat EXIF dates */
    if ($newdate == $date)
      $newdate = preg_replace ('|([0-9]+):([0-9]+):([0-9]+) (.*)|',
                               '\2/\3/\1, \4',
                               $date );
    $newstamp = strtotime ($newdate, $now [0]);
    if ($newstamp == FALSE)
      return '"' . $newdate . "\" is not a valid $type";
    if ($type == "")                            /* take both date and time */
      return getdate ($newstamp);
    else
    {
      $ldate = getdate ($newstamp);
      /* What did he specify?  Date, time or both? */
      if (($ldate ["hours"] == 0)               /* no time specified */
          && ($ldate ["minutes"] == 0)
          && ($ldate ["seconds"] == 0) )
      {
        $ldate ["hours"] = $now ["hours"];      /* use current */
        $ldate ["minutes"] = $now ["minutes"];
        $ldate ["seconds"] = $now ["seconds"];
      }
      else if ("$type" == "date")               /* time specified, shouldn't have done */
        return "Date may not include time";

      /*
       * XXX This is really tacky.  We need to find a better way to ensure that
       * no date is entered.
       */
      if ("$type" == "time")                    /* date specified, shouldn't have done */
      {
        if (($ldate ["mday"] == $now ["mday"])  /* "No date specified */
            && ($ldate ["mon"] == $now ["mon"])
            && ($ldate ["year"] == $now ["year"]) )
          return $ldate;
        $mday = $ldate ["mday"];
        $mon = $ldate ["mon"];
        $year = $ldate ["year"];
        return "Time may not include date ($mday/$mon/$year)";
      }
      /* Normal return */
      return $ldate;
    }
  }
  else                                          /* empty string passed */
    return "Empty date/time string";
 }

/*
 * Take an RCS $Date: 2012/07/09 02:31:38 $ string and convert it to the output format.  This is the
 * same as parsedate, but first trims the dreck at start and end of the string.
 *
 * See printrcsdate() for the canonical example.
 */
function rcsdate ($date)
{
  $foo = preg_replace ("|\\$\Date: (....)/(..)/(..).*|", "\\1\\2\\3", $date);
  return validdate ($foo, "");
}

function printrcsdate ($date)
{
  print (formatdate ("F Y", rcsdate ($date)));
}

/*
 * Given a date $date in getdate() form, add the specified number of seconds and
 * return another date in getdate() form.
 */
function addsecs ($date, $secs)
{
  return getdate ($date [0] + $secs);
}

/*
 * Convert a faked struct tm (in an array) to a time_t and then format it as PHP
 * date () would do.
 */
function formatdate ($format, $tm)
{
  if (is_string ($tm))
    return $tm;
  return date ($format, mktime ($tm ["hours"],
                                $tm ["minutes"],
                                $tm ["seconds"],
/* Beware ugly American sequence breakage */
                                $tm ["mon"],
                                $tm ["mday"],
                                $tm ["year"] ));
}

/*
 * Convert a date into canonical printable form:
 * Saturday, 26 January 2008.
 */
function printdate ($datetext)
{
  return formatdate ("l, j F Y", validdate ($datetext, "date"));
}

/*
 * Given time in the array $timearray, return a date formatted as 26 October
 * 2006.
 */
function datestring ($timearray)
{
  return strftime ("%e %B %Y", $timearray [0]);
}

/*
 * Given time in the array $timearray, return a date formatted as Thursday, 26
 * October 2006.
 */
function daydatestring ($timearray)
{
  return strftime ("%A, %e %B %Y", $timearray [0]);
}

/*
 * Given time in the array $timearray, return a time formatted as H:M:S
 * (15:13:02).
 */
function timestring ($timearray)
{
  return strftime ("%H:%M:%S", $timearray [0]);
}

/*
 * The following functions are not currently usable; they're here in case we
 * need to get them to work.
 */
/*
 * Modified from a function posted by Jae Lee on
 * http://www.php.net/manual/en/function.strtotime.php
 *
 * Purpose : Returns a timestamp from a string based on the given format and
 * default timezone if it's ambiguous.
 *
 * Supported formats
 *
 * %Y - year as a decimal number including the century
 * %m - month as a decimal number (range 01 to 12)
 * %d - day of the month as a decimal number (range 01 to 31)
 *
 * %H - hour as a decimal number using a 24-hour clock (range 00 to 23)
 * %M - minute as a decimal number
 */
function parse_date ($date, $format)
{
  /* Build up date pattern from the given $format, keeping delimiters in place. */
  if (! preg_match_all ("/%([YmdHMp])([^%])*/", $format, $format_tokens, PREG_SET_ORDER))
    return -1;
  foreach ($format_tokens as $format_token)
  {
    $delimiter = preg_quote ($format_token [2], "/" );
    $date_pattern .= "(.*)".$delimiter;
  }

  /* Split up the given $date */
  if (!preg_match ("/".$date_pattern."/", $date, $date_tokens))
  {
    print "datepattern $date_pattern, date $date, date_tokens $date_tokens";
    return -2;
  }

  $date_segments = array ();
  for ($i = 0; $i < count ($format_tokens); $i++)
    $date_segments [$format_tokens [$i] [1]] = $date_tokens [$i+1];

  /*
   * Reformat the given $date into US English date format, suitable for strtotime ().
   * We use US format because that's what strtotime
   * () wants.
   */
  if ($date_segments ["Y"] && $date_segments ["m"] && $date_segments ["d"])
    $date_reformated = $date_segments ["Y"]."-".$date_segments ["m"]."-".$date_segments ["d"];
  else
    return -3;
  if ($date_segments ["H"] && $date_segments ["M"])
    $date_reformated .= " ".$date_segments ["H"].":".$date_segments ["M"];

  return strtotime ($date_reformated);
}

/**
 * $BBId: datefuncs.php,v 1.6 2006/12/13 02:49:53 grog Exp $
 *
 * Modified from a function posted by francesco@pnpitalia.it on
 * http://www.php.net/manual/en/function.strtotime.php
 *
 * Returns a formatted date from a string based on a given format
 *
 * Supported formats
 *
 * %Y - year as a decimal number including the century
 * %m - month as a decimal number (range 1 to 12)
 * %d - day of the month as a decimal number (range 1 to 31)
 *
 * %H - hour as decimal number using a 24-hour clock (range 0 to 23)
 * %M - minute as decimal number
 * %S - second as decimal number
 * %u - microsec as decimal number
 * @param string date  string to convert to date
 * @param string format expected format of the original date
 * @return string rfc3339 w/o timezone YYYY-MM-DD YYYY-MM-DDThh:mm:ss YYYY-MM-DDThh:mm:ss.s
 */
function parseDate ($date, $format)
{
  /* Builds up date pattern from the given $format, keeping delimiters in place. */
  if (!preg_match_all ("/%([YmdHMsu])([^%])*/", $format, $formatTokens, PREG_SET_ORDER))
    return false;
  foreach ($formatTokens as $formatToken)
  {
    $delimiter = preg_quote ($formatToken [2], "/");
    if ($formatToken [1] == 'Y')
      $datePattern .= '(.{1,4})'.$delimiter;
    elseif ($formatToken [1] == 'u')
      $datePattern .= '(.{1,5})'.$delimiter;
    else
      $datePattern .= '(.{1,2})'.$delimiter;
  }

  /* Splits up the given $date */
  if (!preg_match ("/".$datePattern."/", $date, $dateTokens))
    return false;
  $dateSegments = array ();
  for ($i = 0; $i < count ($formatTokens); $i++)
    $dateSegments [$formatTokens [$i] [1]] = $dateTokens [$i+1];

  /* Reformats the given $date into rfc3339 */

  if ($dateSegments ["Y"] && $dateSegments ["m"] && $dateSegments ["d"])
  {
    if (! checkdate ($dateSegments ["m"], $dateSegments ["d"], $dateSegments ["Y"]))
      return false;
    $dateReformated =
    str_pad ($dateSegments ["Y"], 4, '0', STR_PAD_LEFT)
    ."-".str_pad ($dateSegments ["m"], 2, '0', STR_PAD_LEFT)
    ."-".str_pad ($dateSegments ["d"], 2, '0', STR_PAD_LEFT);
  }
  else
    return false;
  if ($dateSegments ["H"] && $dateSegments ["M"])
  {
    $dateReformated .=
    "T".str_pad ($dateSegments ["H"], 2, '0', STR_PAD_LEFT)
    .':'.str_pad ($dateSegments ["M"], 2, '0', STR_PAD_LEFT);

    if ($dateSegments ["s"])
    {
      $dateReformated .=
        ":".str_pad ($dateSegments ["s"], 2, '0', STR_PAD_LEFT);
      if ($dateSegments ["u"])
      {
        $dateReformated .=
          '.'.str_pad ($dateSegments ["u"], 5, '0', STR_PAD_RIGHT);
      }
    }
  }
  return $dateReformated;
}

/*
 * Get a time range, possibly with help of passed parameters, otherwise by
 * default.  $type is $_GET or $_POST
 */
function timeroom ($type)
{
  global $startdate;
  global $enddate;

  $startdate = "";
  $enddate = "";
  if (array_key_exists ("startdate", $type))
  {
    $date = $type ["startdate"];
    if ($date != "")
      /*
       * We don't handle the case of the unspecified start date yet.  That comes
       * after the end date processing.
       */
    {
      $startdate = validdate ($date, "date");
      if (is_string ($startdate))               /* error */
      {
        /* this is the error message */
        print '<p><font color="red">' . $startdate . '</font></p>';
        $startdate = "";                        /* don't use it yet */
      }
    }
  }
  if (array_key_exists ("enddate", $type))
  {
    $date = $type ["enddate"];
    if ($date != "")
    {
      $enddate = validdate ($date, "date");
      if (is_string ($enddate))                 /* error */
      {
        print $enddate;
        $enddate = "";                          /* and reset */
      }
    }
  }

/*
 * Now we have either valid start and end dates, or empty ones.  Decide what to
 * fill in, and how.
 */

  if ($startdate == "")                         /* no start, */
  {
    if ($enddate == "")                         /* and no end */
      $enddate = getdate ();                    /* end defaults to today */
    $startdate = addsecs ($enddate, -86400 * 30); /* either way, start one month earlier */
  }
  else if ($enddate == "")                      /* a month later than start date */
    $enddate = addsecs ($startdate, 86400 * 30); /* one month later */
}

/*
 * Create a a diary link name for the specified date, which is in the form YYYYMMDD.
 * $user is the name of the directory where it should be found.
 * If it isn't, return a null string.
 */
function diarylink ($user, $date)
{
  $photodate = validdate ($date, "date");
  $day = formatdate ("j", $photodate);
  $month = strtolower (formatdate ("MY", $photodate));
  $luser = $_SERVER ['DOCUMENT_ROOT'] . "$user";
  if (file_exists ("$luser/diary-$month.php"))
    return "${user}diary-$month.php#$day";
  else
    return "";
}

/*
 * Display calendar for a single month.  $month is a string from 01 to 12
 * (because that's the way we extract them), $year in format YYYY.  $indent is
 * the number of characters to indent things so that the HTML looks pretty.
 */
function calendarmonth ($month, $year/* , $indent */)
{
  global $monthabbr;
  global $monthinfo;

  print <<< EOS
    <table summary="Calendar" border="3">
                  <tr>
                  <td align="right">Mo</td>
                  <td align="right">Tu</td>
                  <td align="right">We</td>
                  <td align="right">Th</td>
                  <td align="right">Fr</td>
                  <td align="right">Sa</td>
                  <td align="right">So</td>
                  </tr>

EOS;
      $first_weekday = formatdate ("N", validdate ("1/$month/$year", "date")); /* XXX fix this */
      $mday = 2 - $first_weekday;
      if ($month != "02")
        $mdays = $monthinfo [$month] ["days"];
      else                                      /* special case for feb */
      {
        $mdays= 29;
        if ($year % 4)                          /* not a leap year, */
          $mdays = 28;                          /* only 28 */
      }
      while ($mday <= $mdays)
      {
        print "                  <tr>\n";
        for ($wday = 1; $wday < 8; $wday++)
        {
          if (($mday > $mdays) || ($mday < 1))
            print "                    <td></td>\n";
          else
            print "                    <td align=\"right\"><a href=\"#$mday\">$mday</a></td>\n";
          $mday++;
        }
        print "                  </tr>\n";
      }
        print "                </table>\n";
}

/*
 * Display a three month calendar starting at $month.
 *
 * These are two table rows: the first contains the title, the second the
 * calendar itself.
 */
function calendarquarter ($year, $month)
{
  global $monthstring;
  global $monthname;

  print <<< EOS
      <tr>

EOS;
  for ($m = $month; $m < $month + 3; $m++)
  {
    $monthtext = $monthname [$monthstring [$m]];
    print <<< EOS
        <td valign="top" align="center">
           $monthtext $year
        </td>

EOS;
  }
  print <<< EOS
      </tr>

      <tr>

EOS;
  for ($m = $month; $m < $month + 3; $m++)
  {
    print <<< EOS
        <td valign="top">

EOS;

    calendarmonth ($monthstring [$m], $year);
    print <<< EOS

        </td>

EOS;
  }

  print <<< EOS
      </tr>

EOS;
}

/*
 * Display a calendar encompassing dates $start to $end.
 */
function calendaryear ($year)
{
  global $monthstring;
  print <<< EOS
    <font size="1">
    <table>

EOS;
  for ($quarter = 1; $quarter < 12; $quarter += 3)
    calendarquarter ($year, $quarter);

  print <<< EOS
    </table>
    </font>

EOS;
}

/*
 * Return the name of the diary for this date, if it exists, otherwise an empty
 * string.
 */
function diaryname ($date, $who)
{

  $diarydate = validdate ($date, "date");
  $day = formatdate ("j", $diarydate);
  $month = strtolower (formatdate ("M", $diarydate));
  $year = formatdate ("Y", $diarydate);
/* File and URL of corresponding diary entry */
  $diary = "diary-$month$year.php";
  /* Another horrible kludge, to be fixed XXX */
  if (file_exists ("/home/$who/public_html/$diary"))
    return "/$who/$diary#$day";
  else
    return "";
}

/*
 * Format a passed RCS ID in legible format.
 * $format defaults to 18 June 2012.
 */
function formatRCSID ($id /* , $format*/)
{
  if (func_num_args () > 1)
    $format = func_get_arg (1);
  else
    $format = "j F Y";
  return formatdate ("j F Y", rcsdate ($id));
}
?>