<?php  /* Hey, emacs!  Edit this file as -*- mode: php; coding: utf-8 -*- */
  /* $Id: docontacts.php,v 1.7 2012/05/09 22:58:04 grog Exp $ */
/* This file assumes that header.php has already been read in. */

/*
 * Build the contents of a contact print page.
 *
 * $desc is the description that will become the title.  This can be overwritten
 *       by the config file.
 * $dirdate is the directory date.
 * $imagelist is a list of image file names in this directory.
 */
function docontacts ($desc, $dirdate, $imagelist)
{
  global $me;                                   /* name of this script */
  $namespec = array ();
  $lastname = "Unnamed-photo-";
  $lastseq = 0;
  $bang = 0;                                    /* don't repeat previous image names */
  $images = explode (" ", trim ($imagelist));   /* individual names */
  $autofocus = "";                              /* attribute to set focus on input field */
  $lastfocus = "";                              /* last field with input */
  $banging = 0;                                 /* not propagating yet */

/*  phpinfo (); */

  /* We already have a config file.  Read it in. */
  if (file_exists ("Makejpeg"))
  {
    $parms = explode ("\n", file_get_contents ("Makejpeg"));
    $desc = $parms [0];                         /* first line is description. */
    $imagenum = 1;
    while (array_key_exists ($imagenum, $parms))
    {
      /*
       * Lines describing image:
       *
       * Source-file  Dest-file  rotation
       */
      $imagedesc = explode (" ", $parms [$imagenum]);
/* XXX       print "<pre>";
      print_r ($imagedesc);
      print "</pre>"; */
      if (array_key_exists (1, $imagedesc))
      {
        $namespec [$imagedesc [0]] = $imagedesc [1];
        if (array_key_exists (2, $imagedesc))
          $rotation [$imagedesc [0]] = $imagedesc [2];
        else
          $rotation [$imagedesc [0]] = 0;
        $lastname = preg_replace ("/[0-9]+$/", "", $imagedesc [1]);
        $lastseq = preg_replace ("/^[^0-9]*([0-9]+)$/", "\\1", $imagedesc [1]);
/*        printf ("<pre>%s %s</pre>", $lastname, $lastseq); */
      }
      $imagenum++;
    }
  }

  /*
   * Now we have the existing config, if any.  See if we have new parms.
   */
  if (array_key_exists ("desc", $_REQUEST)
      || array_key_exists ("image", $_REQUEST) )
  {
    if (0)                                      /* XXX */
    {
      print_r ($_REQUEST);
      print_r ($imagenames);
    }

    if (array_key_exists ("desc", $_REQUEST))
      $desc = $_REQUEST ["desc"];
    if (array_key_exists ("image", $_REQUEST))
      $imagenames = $_REQUEST ["image"];

    /*
     * Process the input names.  We do this in two stages.  Here we collect the
     * names, and in a second loop we apply them.
     *
     * Possible name specs are:
     *
     * ,	Take the last name of the form foo-3 and generate a new name foo-4 by
     * 		incrementing the number after the -.
     * !        Generate a whole series foo-4, foo-5 and so on up to the next input.
     * =        Take the name from the source image.
     * other    Use the name directly.
     * (empty)  Do nothing unless $banging is set, and then propagate the last name.
     *
     * Yes, the comparison needs to be like this, otherwise the loop will
     * terminate on the first empty field.
     */
    while (($imagespec = current ($imagenames)) !== FALSE)
    {
      if  (0)                                   /* XXX */
      {
        print "<pre>";
        print_r ($imagespec);
        print "</pre>";
      }
      $key = key ($imagenames);
      $imagedesc = explode (" ", $imagespec);
      /* $imagedesc now contains
       * Element 0: name
       * Element 1: rotation (maybe).
       */
      $imagename = $imagedesc [0];
/*      printf ("<pre>%s %d %d</pre>\n", $imagename, $bang, $banging);  /* XXX */
      if (array_key_exists (1, $imagedesc))     /* rotation specified, */
        $rotate = $imagedesc [1];               /* get it */
      else
        $rotate = 0;                            /* default to no rotation */
      if  ($imagename == ",")                   /* take name from previous */
      {
        $lastseq ++;
        $namespec [$key] = "$lastname$lastseq";
        $rotation [$key] = $lastrotation;
      }
      else if ($imagename == "=")               /* copy source name */
      {
        $namespec [$key] = $key;
        $rotation [$key] = $rotate;
      }
      else
      {
        $namespec [$key] = $imagename;
        if ($imagename == "!")                  /* propagating, */
          $bang = 1;                            /* note it */
        {
          $rotation [$key] = $rotate;
          $lastname = preg_replace ("/[0-9]+$/", "", $imagename);
          $lastseq = preg_replace ("/^[^0-9]*([0-9]+)$/", "\\1", $imagename);
          $lastrotation = $rotation [$key];
        }
      }
/*      printf ("<pre>%s %s</pre>", $lastname, $lastseq); */
/*      printf ("<pre>'%s' '%s' '%s'</pre>\n", $imagespec, key ($imagenames), $namespec); */
      next ($imagenames);
    }

    /* Second time through */
    if (1)                                      /* XXX we need to propagate things */
    {
      /* Defaults if we hit a ! before a real name. */
      $lastname = "Unknown-image-";
      $lastseq = 0;
      $lastrot = 0;
      $prevkeys = "";                           /* list of previouly seen keys */
      foreach ($images as $image)               /* each image */
      {
        $key = basename ($image, ".jpg");
        $key = basename ($key, ".JPEG");
        if (array_key_exists ($key, $namespec)) /* we have an entry for this key */
        {
          $imagename = $namespec [$key];
          if ($imagename != "")                 /* we have some kind of input, handle it */
          {
            $lastfocus = $key;                  /* keep this to set focus on display */
            if ($imagename == "!")
            {
              $lastseq++;
              $namespec [$key] = $lastname.$lastseq;
              $rotation [$key] = $lastrot;
              $banging = 1;                     /* we're propagating until we find a name again */
            }
            else if (substr ($imagename, -1) == ",") /* search back for text */
            {
              $keytext = substr ($imagename, 0, -1); /* all except the last line */
              $keylen = strlen ($keytext);
              $keys = explode (" ", $prevkeys);
/*            printf ("<pre>keytext %s, keylen %d, keys '%s'</pre>\n", $keytext, $keylen, $prevkeys);
              print_r ($keys); */
              foreach ($keys as $oldkey)        /* search backwards */
              {
/*  XXX              printf ("<pre>Key %s</pre>\n", $oldkey); */
                /*
                 * For some reason we end up with a bogus key at the end.  Catch
                 * it.
                 */
                if (! array_key_exists ($oldkey, $namespec))
                  break;
                else if (! strncmp ($keytext, $namespec [$oldkey], $keylen)) /* found it */
                {
                  /* Get the details from the old entry. */
                  $oldname = $namespec [$oldkey];
                  $lastname = preg_replace ("/[0-9]+$/", "", $oldname);
                  $lastseq = preg_replace ("/^[^0-9]*([0-9]+)$/", "\\1", $oldname);
                  $lastrotation = $rotation [$oldkey];
                  /* And apply them to this one */
                  $lastseq ++;
                  $namespec [$key] = "$lastname$lastseq";
                  $rotation [$key] = $lastrotation;
                  break;
                }
              }
              /* We can come out here without finding anything.  Is that an issue? */
              $banging = 0;
            }
            else                                /* real name, note it */
            {
              $lastname = preg_replace ("/[0-9]+$/", "", $imagename);
              $lastseq = preg_replace ("/^[^0-9]*([0-9]+)$/", "\\1", $imagename);
              $lastrotation = $rotation [$key];
              $banging = 0;
            }
            $prevkeys = "$key $prevkeys";       /* prepend this key to the ones we've seen */
          }
          else if ($banging)                      /* no key, but propagating */
          {
/*            printf ("<pre>Image %s, Key %s, banging %d<pre>", $image, $key, $banging); */

            $lastseq++;
            $namespec [$key] = $lastname.$lastseq;
            $rotation [$key] = $lastrot;
          }
        }
      }
      $bang = 0;                                /* Don't come here again  */
    }

    /*
     * Now we have something to save.
     */
    if (! ($configfile = fopen ("Makejpeg", "w")))
      {
        printf ("</body></html>");
        exit ();
      }
    fprintf ($configfile, "%s\n", $desc);
    while (($spec = current ($namespec)) !== FALSE) /* PHP, how I love you */
    {
      if ($spec)                                /* it's not FALSE, but it could be empty */
      {
        $key = key ($namespec);
        fprintf ($configfile,"%s %s %d\n", $key, $spec, $rotation [$key]);
      }
      next ($namespec);
    }
    fclose ($configfile);
  }

/*  print "<pre>";
  print_r ($namespec);
  print "</pre>"; */

    /* Start building up the page. */

  print <<< EOS
<form action="$me" method="post">
      <span>Description:</span>
      <input size="128" maxlength="1024" type="text" name="desc"
             value="$desc" />
      <input type="submit" value="Submit "/>
      <span>

EOS;
  $col = 1;
  $imagenum = 1;

/*  print "imagelist $imagelist\n";
    print "images $images[0]\n"; */
  foreach ($images as $image)                   /* each image */
  {
    if ($col == 1)                              /* start of row */
    print <<< EOS
        <table>
          <tr>

EOS;

    /*
     * Highlight .jpg files, which have been processed locally.
     * I don't know if this makes sense any more.
     */
    if (preg_match ("/.jpg$/", $image))
      $imagename = "<font color=\"green\"><b>$image</b></font>";
    else
      $imagename = $image;
    $key = preg_replace ("/.jpg$|.JPG$|.JPEG$|.jpeg$/", "", $image);
    $exiffile = "$key.exif";
    print <<< EOS
            <td>
              <table>
                <tr>
                  <td>
                    <a id="image_$imagenum"
                       onMouseOver="stm (exif_info [$imagenum], Style)"
                       onMouseOut="htm()"
                       href="/grog/Rawphotos/$dirdate/orig/$image">
                       <img alt="$image" border="0"
                            title="$image"
                            src="$image" />
                    </a>
                  </td>
                </tr>
                <tr>
                  <td>
                    $imagename
                  </td>
                </tr>

EOS;
    if (islocal ())
    {
      if (array_key_exists ($key, $namespec))
      {
        $myname = $namespec [$key];
        if ($rotation [$key] != 0)
          $myname .= " $rotation[$key]";
      }
      else
        $myname = "";
      print <<< EOS
                <tr>
                  <td>
                     <input size="25" maxlength="1024" type="text" name="image[$key]"
                            value="$myname" $autofocus />
                   </td>
                 </tr>
EOS;
      if ($key == $lastfocus)               /* this was the last input field last time round, */
        $autofocus = "autofocus";           /* do a focus once only next time round. */
      else
        $autofocus = "";
    }
    if (file_exists ("$exiffile"))
    {
      $exifdata = exposuredetails ("$exiffile", "j");
      if ($exifdata != "")
        print <<< EOS
          <script type="text/javascript">
             <!--
             exif_info [$imagenum] = ["Image $image",
                              "$exifdata"];
             // -->
          </script>

EOS;
    }
    print <<< EOS

              </table>
            </td>

EOS;

    $imagenum++;
    if (++$col > 6)                             /* end of row */
    {
      print <<< EOS
            </tr>
          </table>

EOS;
      $col = 1;
    }
  }

  print <<< EOS
        </tr>
      </table>
    </span>
    <input type="submit" value="Submit "/>
  </form>

EOS;

}
