<?php  /* Hey, emacs!  Edit this file in -*- php -*- mode! */
  /* $Id: exifdetails.php,v 1.3 2012/07/09 02:32:03 grog Exp $ */

/*
 * XXX experimental stuff.  Print a string with most exif details, suitable for use as a
 * file name component (i.e. no spaces).
 */
function exposuredetails ($exif_file, $format)
{
  $manufacturer = "";
  $model = "";
  $date = "";
  $author = "";
  $shutter = "";
  $aperture = "";
  $ISO = "";
  $light_value = 0;
  $metermode = "";
  $EV = "";
  $flash = "";
  $flash_mode = "";
  $flash_comp = "";
  $external_flash = "";
  $external_flash_bounce = "";
  $external_flash_zoom = "";
  $manual_flash = "";
  /*
   * These two together determine the Mecablitz 58 AF 1 unit: it reports itself
   * as an Olympus FL-50R with a serial number 000058:1.
   */
  $flash_model = "";
  $flash_serial = "";
  $focal_length = "";
  $scale_factor = "";
  $equivalent_focal_length = "";
  $extender = "None";                           /* default return value from exiftool */
  $saturation = "";
  $lens = "";
  $focus = "";
  $focus_mode = "";
  $depth_of_field = "";
  $details = "";                                /* fill details in here */

  $fd = fopen ("$exif_file", "r");
  while ($info = fgets ($fd))
  {
    if ($author == "")
    {
      if (ereg ("^Author *:(.*)", $info, $parts))
        $author = trim ($parts [1]);
    }
    if ($manufacturer == "")
    {
      if ((ereg ("^Make *: (.*)", $info, $parts))
          || (ereg ("^Manufacturer *\|(.*)", $info, $parts)) )
        $manufacturer = trim ($parts [1]);
    }
    if ($model == "")
    {
      if ((ereg ("^Camera Model Name *:(.*)", $info, $parts))
          || (ereg ("^Model *\|(.*)", $info, $parts)) )
        $model = trim ($parts [1]);
    }
    if ($date == "")
    {
      if ((ereg ("^Date/Time Original *:(.*)", $info, $parts))
          || (ereg ("^Date and Time.*ori.*\|(.*)", $info, $parts)) )
        $date = formatdate ("l, j F Y, G:i:s", validdate (trim ($parts [1]), ""));
    }
    if ($shutter == "")
    {
      if (ereg ("^Exposure Time *:(.*)", $info, $parts))
        $shutter = trim ($parts [1]) . " sec";
      else if (ereg ("^Exposure Time *\|(.*)", $info, $parts))
        $shutter = trim ($parts [1]);
    }
    if ($aperture == "")
    {
      if (ereg ("^Aperture *: (.*)", $info, $parts))
        $aperture = "f/" . trim ($parts [1]);
      else if (ereg ("^FNumber *\|(.*)", $info, $parts))
        $aperture = trim ($parts [1]);
      if ($aperture == "f/0.0")                 /* unknown */
        $aperture = "<i>aperture unknown</i>";
    }
    if  ($ISO == "")
    {
      if (ereg ("^ISO  *: (.*)", $info, $parts)
          || (ereg ("^ISO Speed Ratings *\|(.*)", $info, $parts)) )
        $ISO = trim ($parts [1]);
    }
    if  ($light_value == 0)
    {
      if (ereg ("^Light Value  *: (.*)", $info, $parts))
        $light_value = trim ($parts [1]);
    }
    if ($metermode == "")
    {
      if (ereg ("^Metering Mode *[|:] *(.*)", $info, $parts))
        $metermode = trim ($parts [1]);
    }
    if  ($EV == "")
    {
      if (ereg ("^Exposure Compensation *: (.*)", $info, $parts))
        $EV = trim ($parts [1]) . " EV";
      else if (ereg ("^Exposure Bias *\|(.*)", $info, $parts))
        $EV = trim ($parts [1]);
    }
    if ($flash == "")
    {
      if (ereg ("^Flash *[|:] *(.*)", $info, $parts))
      {
        $flash = trim ($parts [1]);
        /* Sometimes only we get "On,  " at the beginning here */
        $flash = preg_replace ("|On, (.*)|", "\\1", $flash);
        /* We don't want to know about non-events */
        if ($flash == "Did not fire")
          $flash = "";
      }
    }
    if ($flash_mode == "")
    {
      if (ereg ("^Flash Mode *: (.*)", $info, $parts))
      {
        $flash_mode = trim ($parts [1]);
        /* Sometimes only we get "On,  " at the beginning here */
        $flash_mode = preg_replace ("|On, (.*)|", "\\1", $flash_mode);
      }
    }
    if ($flash_model == "")
    {
      if (ereg ("^Flash Model *: (.*)", $info, $parts))
        $flash_model = trim ($parts [1]);
    }
    if ($flash_serial == "")
    {
      if (ereg ("^Flash Serial Number *: (.*)", $info, $parts))
        $flash_serial = trim ($parts [1]);
    }
    if ($flash_comp == "")
    {
      if (ereg ("^Flash Exposure Comp *: (.*)", $info, $parts))
      {
        $flash_comp = trim ($parts [1]);
        if (substr ($flash_comp, 0, 1) != "-")
          $flash_comp = "+$flash_comp";
      }
    }
    if ($manual_flash == "")
    {
      if (ereg ("^Manual Flash *: On (.*)", $info, $parts))
        $manual_flash = trim ($parts [1]);
    }
    if ($external_flash == "")
    {
      if (ereg ("^External Flash *: (.*)", $info, $parts))
        $external_flash = trim ($parts [1]);
      if ($external_flash == "Off")             /* reported, but not there */
        $external_flash = "";
    }
    if ($external_flash_bounce == "")
    {
      if (ereg ("^External Flash Bounce *: (.*)", $info, $parts))
        $external_flash_bounce = trim ($parts [1]);
      if ($external_flash_bounce == "Off")
        $external_flash_bounce = "";
    }
    if ($external_flash_zoom == "")
    {
      if (ereg ("^External Flash Zoom *: (.*)", $info, $parts))
      {
        if (($external_flash_zoom = trim ($parts [1])) == "0")
          $external_flash_zoom = "";
      }
    }
    if ($saturation == "")
    {
      if (ereg ("^Saturation *:(.*)", $info, $parts))
        $saturation = trim ($parts [1]) . " saturation";
      else if (ereg ("^Saturation *\|(.*)", $info, $parts))
        $saturation = trim ($parts [1]);
    }
    if ($focus == "")
    {
      if (ereg ("^Focus Distance *:(.*)", $info, $parts))
        $focus = trim ($parts [1]);
    }
    /* XXX focus mode appears to be reported incorrectly */
    if ($focus_mode == "")
    {
      if (ereg ("^Focus Mode *:([ A-Z]*)", $info, $parts))
        $focus_mode = trim ($parts [1]);
    }
    if ($depth_of_field == "")
    {
      if (ereg ("^Depth Of Field *:.*(\(.*\))", $info, $parts))
        $depth_of_field = trim ($parts [1]);
    }
    /*
     * At least for the Olympus E-510, exiftool returns two different "Focal
     * Length" entries.  They have the same value (fortunately!), but the second
     * one includes a rough 35 mm equivalent.  This code attempts to extract
     * that info, so we don't check if $focal_length is already set.  On the
     * other hand, we can calculate the equivalent focal length better than
     * exiftool, so if we find a "Scale Factor To 35 mm Equivalent", we'll take
     * that in preference.
     */
    if (ereg ("^Focal Length *[|:](.*)", $info, $parts))
    {
      if ($focal_length == "")
        $focal_length = trim ($parts [1]);
      if ($focal_length == "0.0 mm")
        $focal_length = "<i>unknown</i>";
      if (($equivalent_focal_length == "")
          && (ereg ("\(35 mm equivalent: ([^0].*)\)", $info, $parts)) )
        $equivalent_focal_length = trim ($parts [1]);
    }
    if (ereg ("^Scale Factor To 35 mm Equivalent *[:](.*)", $info, $parts))
      $scale_factor = trim ($parts [1]);
    if (($extender == "None")
        && (ereg ("^Extender *: (.*)", $info, $parts)) )
      $extender = trim ($parts [1]);
    if (($lens == "")
        && (ereg ("^Lens Type *: (.*)", $info, $parts)) )
    {
      $lens = trim ($parts [1]);
      if ($lens == "None")                      /* no lens info, from Olympus */
        $lens = "";
    }
    /* This seems to happen on Pentaces */
    if ($equivalent_focal_length == "")
    {
      if (ereg ("^Focal Length In 35mm *\|(.*)", $info, $parts))
      {
        $equivalent_focal_length = trim ($parts [1]);
        if ($equivalent_focal_length == "0.0 mm") /* none */
          $equivalent_focal_length = "";        /* reset */
      }
    }
  }
  fclose ($fd);

  if ($EV != "0 EV")
    $rawname = "$model-$lens-$shutter-$aperture-$EV-$focal_length-$ISO-ISO.jpeg";
  else
    $rawname = "$model-$lens-$shutter-$aperture-$focal_length-$ISO-ISO.jpeg";
  return preg_replace ("| |", "-",
                       preg_replace ("|/|", "-",
                                     (preg_replace ("|--+|", "-", $rawname)) ) );
  }
