<?php  /* Hey, emacs!  Edit this file in -*- php -*- mode! */

/*
 * $Id: header.php,v 1.213 2012/07/10 23:54:56 grog Exp $
 * Header for "standaard web" pages.  This starts the page and goes down to the
 * table at the start of the body.
 */

include "datefuncs.php";
include "utils.php";
include "onephoto.php";

/* variables for daytitle */
$firstday = 0;                                  /* first day we specify */
$yesterday = 0;                                 /* day of previous title */
$lastday = 0;                                   /* set on last day in current file */
$seen_lastday = 0;                              /* set when we see a set $lastday */
$missing_days = "";                             /* list of any missing days */
$isrss = 0;                                     /* not an RSS feed until proof of the contrary */
$servername = "http://" . $_SERVER ["SERVER_NAME"]; /* for generated URLs */
$me = $_SERVER ["PHP_SELF"];                    /* name of this script */
$nextmonth = "";                                /* globals for diary headers */
$lastmonth = "";                                /* globals for diary headers */
$topics = "";                                   /* set if we have topics for diary entries */
$havetopics = 0;                                /* set in the source file if it specifies topics */
$tomorrow = 0;                                  /* for forward links */
$current_topic = "";                            /* current topic */
$missing_topics = "";
$title_number = 0;                              /* number of title for shortdaytitle () */
$acmtitle = "";                                 /* kludge header for ACM Queue */
$PubDate = "";
$islocal = $_SERVER ["HTTP_HOST"] == "wwww.lemis.com";
$origlink = "";                                 /* link from RSS to HTML original */

/*
 * Mask for days in diary.  This is used to grey out unused entries in the
 * calendar.  2**0 represents day 1, etc.  This can be overridden in the source
 * file.
 */
$daymask = 0x7fffffff;
/* Adding topics: modify this array and $alltopics somewhere below. */
$topicnames = array ("a" => "animals",
                     "b" => "brewing",
                     "c" => "technology",
                     "k" => "cooking",
                     "f" => "fiction",
                     "g" => "gardening",
                     "h" => "general",
                     "H" => "history",
                     "l" => "language",
                     "t" => "multimedia",
                     "m" => "music",
                     "o" => "opinion",
                     "p" => "photography" );

/*
 * Check whether we've gotten a diarydate.  If so, check for a diary entry and
 * go there if possible.  If the entry doesn't exist, go to the diary overview
 * page.
 *
 * This is ugly, because it applies to all pages, but it doesn't really do any
 * harm.
 */
if (array_key_exists ("diarydate", $_GET))
{
  $date = $_GET ["diarydate"];
  if ($date != "")
  {
    if (strlen ($date) == 6)                    /* no day specified */
      $date .= "01";                            /* start at beginning of month */
    $diarydate = validdate ($date, "date");
    if (! is_string ($diarydate))               /* valid date */
    {
      $day = formatdate ("j", $diarydate);
      $month = strtolower (formatdate ("M", $diarydate));
      $year = formatdate ("Y", $diarydate);
      /* File and URL of corresponding diary entry */
      $diary = "diary-$month$year";
      $URL = "$diary.php";
      if (file_exists ($URL))
        print '<meta http-equiv="refresh" content="0;URL=' . $URL . "#$day" . '">';
      else
        print '<meta http-equiv="refresh" content="0;URL=diary-about.php?wrongdate=' . $date. '">';
      exit (0);
    }
    else                                        /* invalid date */
      /* this is the error message */
      print '<p><font color="red">' . $diarydate . '</font></p>';
  }
}

/* override our idea of local? */
if (array_key_exists ("local", $_GET))
  $islocal = $_GET ["local"];

/*
 * Topics for display.  What a mess!
 */
if (array_key_exists ("topics", $_GET))         /* for sane human passing */
  $topics = $_GET ["topics"];
else
  $topics = "";
if (array_key_exists ("topics", $_POST))
{
  $topiclist = $_POST ["topics"];
  foreach ($topiclist as $topic)
    $topics .= $topic;
}

if (array_key_exists ("showdetails", $_GET))
  $showdetails = $_GET ["showdetails"];
else
  $showdetails = "";
$showdetail_button = 0;                         /* count the buttons so we can position on them */

/* Default global values */
$rightextras = "";

/* Work out who we are.  Some of the functions use this */
preg_match ("|/([^/]+)|", $_SERVER ["SCRIPT_NAME"], $parts);
$who = $parts [1];                              /* top-level path name */
if ("$who" == "grog")
  $whoname = "Greg";
else if ("$who" == "yvonne")
  $whoname = "Yvonne";
else if ("$who" == "chris")
  $whoname = "Chris";
else
   $whoname = $who;

$homedir = "$_SERVER[DOCUMENT_ROOT]/$who";      /* and note for later use */
$meta_keywords = "Lehey";                       /* default meta keywords */
/*
 * Meta description defaults to title.  This will only work if $title is defined
 * before including this file.
 */
if (isset ($title))
  $meta_description = $title;
else
  $meta_description = "$whoname Lehey's random web page"; /* and meta description */

/*
 * Title with personal name
 */
function pagetitle ($title)
{
  global $whoname;
  global $meta_description;
  global $meta_keywords;

  /* XXX kill this */
  if ($whoname == "Yvonne")
    $charset = "iso-8859-1";
  else
    $charset = "utf-8";

  print <<< EOS
<meta name="description" content="$meta_description" />
    <meta name="keywords" content="$meta_keywords" />
    <meta name="pinterest" content="nopin" />
    <meta http-equiv="Content-Type" content="text/html; charset=$charset" />

EOS;
  javaheader ();
  /* At least firefox can't handle — in the header. */
  $title = str_replace ("—", "--", $title);
  print <<< EOS
    <title>${whoname}&apos;s $title</title>

EOS;
  include "css.php";
}

/*
 * Title without personal name.  This is the same as pagetitle() except for the
 * <title> line.
 */
function pagetitle0 ($title)
{
  global $whoname;
  global $meta_description;
  global $meta_keywords;

  /* XXX kill this */
  if ($whoname == "Yvonne")
    $charset = "iso-8859-1";
  else
    $charset = "utf-8";

  print <<< EOS
<meta name="description" content="$meta_description" />
    <meta name="keywords" content="$meta_keywords" />
    <meta name="pinterest" content="nopin" />
    <meta http-equiv="Content-Type" content="text/html; charset=$charset" />
EOS;
  javaheader ();
  /* At least firefox can't handle — in the header. */
  $title = str_replace ("—", "--", $title);
  print <<< EOS
    <title>$title</title>
    <style type="text/css">
      div.c2 {font-size: 80%; text-align: center}
      div.c1 {text-align: center}
    </style>

EOS;
  include "css.php";
}

/*
 * Display the left part of the header for a diary page.
 */
function leftheader ($photo)
{
  global $whoname;
  global $topics;
  global $topicnames;
  global $havetopics;
  global $me;

  print <<< EOS
        <td width="25%">
          <table summary="left part of header">
            <tr>
              <td>
                <img $photo alt="$whoname" />
              </td>
            </tr>

EOS;
  if ($havetopics)
  {
    print <<< EOS
            <tr>
              <td>
              </td>
            </tr>

            <tr>
              <td>

EOS;
  /*
   * Display a selection menu for the topics
   */
    $alltopics = "albtkmfogphcH";               /* 2 columns */
/*  "abkfghHltmopc"; */
    $numtopics = strlen ($alltopics);
  print <<< EOS
                <form action="$me" method="post">
                  <input type="submit" value="Show selected topics:" />
                    <table class="width: 20ex">

EOS;
  /*
   * XXX When changing $cols, reorder $alltopics to get the columns alphetically
   * sorted.
   */
  $cols = 2;                                    /* do this in 2 columns */
  $colcount = $numtopics / $cols;
  $col = $numtopics % $cols;
  $i = 0;

  while ($i < $numtopics)
  {
    print <<< EOS
                      <tr>

EOS;
    for ($col = 0; $col < $cols; $col++)
    {
      $topicchar = $alltopics [$i];             /* single letter abbreviation */
      $topicstring = $topicnames [$topicchar];  /* and descriptive string */
      /* Decide whether to select this topic */
      if (on_topic ($topicchar, $topics) > 0)
        $select = ' checked="checked"';
      else
        $select = "";
      print <<< EOS
                        <td class="width: 20ex">
                          <input type="checkbox" name="topics[]" $select value="$topicchar" />
                          <span class="font-size: 80%; width: 20ex">$topicstring</span>
                        </td>

EOS;
      $i++;
      if ($i == $numtopics)                     /* done! */
        break;
    }
    print <<< EOS
                      </tr>

EOS;
  }
  print <<< EOS
                  </table>
                </form>

EOS;
  if ($topics != "")                            /* we're limited, */
    print <<< EOS
                <form action="$me" method="get">
                  <input type="submit" value="Show all topics" />
                </form>

EOS;
  print <<< EOS
              </td>
            </tr>

EOS;
  } /* End of $havetopics */

  print <<< EOS
          </table>
        </td>

EOS;
} /* End of leftheader */

/*
 * Lay out the right side of the page header.  We have the following options:
 *
 * 1: If a parameter is passed, it's a custom $rightmenu.  Override any global.
 *
 * 2: If there's a variable $rightmenu, use it.  It should be a list of URLs and
 *     texts, not the same format as rightmenu.php.  Note that the test for this
 *     occurs partially after (3) below.
 *
 * 3: If there's a file rightmenu.php in the same directory as the page, use
 *    it.  It needs to be a td with right alignment.
 *
 * 4: Otherwise use our own default $rightmenu.
 *
 * 5: If there's a file rightextras in the same directory as the page, use it.
 *    It should be in the same format as $rightextras: pairs of URL and text,
 *    separated by the first space.
 *
 * 6: Add any contents of the variable $rightextras to the $rightmenu.
 *
 * In cases 3 to 5, then build a <td> sequence around it.
 *
 * Options 3 to 5 also include a Groogle search menu.  Option 2 doesn't.
 */
function rightmenu ()
{
  global $rightextras;
  global $rightmenu;
  global $startdate;
  global $enddate;
  global $who;
  global $whoname;
  global $monthabbr;                            /* name of month (jan, feb, etc) */
  global $monthinfo;                            /* array of info on month */
  global $year;                                 /* YYYY form */
  global $diary;                                /* could be used by rightmenu files */
  global $daymask;

  /*
   * It's too painful to pass multiple args here some of the time, so do it via
   * a global.
   */
  global $isdiary;

  if (func_num_args () > 0)
    $rightmenu = func_get_arg (0);

  if (file_exists ("rightmenu.php")
    && (! isset ($rightmenu)) )
  {
    print "
<!-- Custom heading -->
";
    include "rightmenu.php";
    print <<< EOS
      </tr>
    </table>

EOS;
  }
  else
  {
    /* XXX this needs to be fixed */
  if ((! isset ($rightmenu))
      && ($who == "grog") )                     /* default menu */
  {
    $rightmenu = "/$who/diary.php $whoname's diary\n";
    if ((isset ($startdate) && isset ($enddate))
        && (gettype ($startdate) == "string") )
      $rightmenu .= "/$who/photos/photos.php?startdate=$startdate&enddate=$enddate Photo index\n";
    else
      $rightmenu .= "/$who/photos/photos.php Photo index\n";
    $rightmenu .= <<< EOS
/grog/index.php $whoname's home page
/grog/3gstats.php Network link stats
/grog/grogslinks.html $whoname's other links
/grog/copyright.php Copyright information

EOS;
  }

  if (file_exists ("rightextras"))
    $rightextras .= file_get_contents ("rightextras");
  $rightmenu .= $rightextras;                   /* add any extras */
  $mymask = $daymask;                           /* mask of days represented on this page */
  print <<< EOS

        <td align="right" width="35%">
          <table summary="Links and maybe calendar">
            <tr valign="top">                   <!-- calendar and most links -->
              <td align="left">

EOS;
    if ($isdiary == 2)                          /* diary with month associated */
    {
    print <<< EOS
                <table><tr><td>Select day:</td></tr></table>
                <table summary="Calendar" border="3">
                  <tr>
                  <td align="right">Mo</td>
                  <td align="right">Tu</td>
                  <td align="right">We</td>
                  <td align="right">Th</td>
                  <td align="right">Fr</td>
                  <td align="right">Sa</td>
                  <td align="right">Su</td>
                  </tr>

EOS;
      $first_weekday = formatdate ("N", validdate ("1 $monthabbr $year", "date"));
      $mday = 2 - $first_weekday;
      if ($monthabbr != "feb")
        $mdays = $monthinfo [$monthabbr] ["days"];
      else                                      /* special case for feb */
      {
        $mdays= 29;
        if ($year % 4)                          /* not a leap year, */
          $mdays = 28;                          /* only 28 */
      }
      while ($mday <= $mdays)
      {
        print "                  <tr>\n";
        for ($wday = 1; $wday < 8; $wday++)
        {
          if (($mday > $mdays) || ($mday < 1))
            print "                    <td></td>\n";
          else if ($daymask & (1 << ($mday - 1)))
            print "                    <td align=\"right\"><a href=\"#$mday\">$mday</a></td>\n";
          else
            print "                    <td align=\"right\"><font color=\"grey\">$mday</td>\n";
          $mday++;
        }
        print "                  </tr>\n";
      }
        print "                </table>\n";

    }

    print <<< EOS
              </td>
              <td align="right">
                <table summary="Links">
EOS;

    /* Now do the individual entries */
    $items = explode ("\n", $rightmenu);
    foreach ($items as $item)
    {
      if (preg_match ("|([^ ]+) (.+)|", trim ($item), $parts))
        print <<< EOS

                  <tr>
                    <td align="right"><a href="$parts[1]">$parts[2]</a></td>
                  </tr>

EOS;
    }
    print <<< EOS
                </table>
              </td>
            </tr>
EOS;
    if ($isdiary && ($who == "grog"))
      print <<< EOS

            <!-- Diary date selection, only for diaries -->
            <tr align="left">
              <td colspan="2">
                <form action="diary.php" method="get">
                  <table summary="Parameter input" cellspacing="2" border="0">
                    <tr>
                      <td>
                        <input type="submit" value="New date:"/>
                      </td>

                      <td>
                            &nbsp;&nbsp;&nbsp;&nbsp;
                      </td>

                      <!-- value -->
                      <td>
                        <input size="10" maxlength="20" type="text" name="diarydate" />
                      </td>
                    </tr>
                  </table>
                </form>
              </td>
            </tr>
EOS;
    print <<< EOS

            <!-- Groogle search window -->
            <tr>
              <td colspan="2">
                <form method="get" action="http://www.google.com/search">
                  <table summary="Groogle search form">
                    <tbody>
                      <tr>
                        <td align="right" colspan="2"><input type="text" name="q" size="30"
                        maxlength="255" value="" /></td>
                      </tr>

                      <tr>
                        <td><a href="http://www.google.com/"><img
                        src="http://www.google.com/logos/Logo_40wht.gif" border="0"
                        width="128" height="53" alt="Groogle" /></a></td>
                        <td><input type="submit" name="btnG" value="Groogle Search" /></td>
                      </tr>
                    </tbody>
                  </table>
                </form>
              </td>
            </tr>                               <!-- end of Groogle window -->
          </table>                              <!-- end of link and calendar table -->
        </td>
      </tr>
    </table>

EOS;
  }
}

/*
 * Print a page header with no extras */
function pageheader0 ($title)
{
  global $subtitle;
  global $isdiary;
  global $who;
  global $whoname;

  $isdiary = 0;                                 /* don't do diary-specific stuff in rightmenu */

  javaincludes ();                              /* put in Javascript stuff */
  print <<< EOS
    <table summary="heading" width="100%">
      <tr>
EOS;
  if ($who == "grog")
  {
    print <<< EOS

        <td>
          <img src="/grog/grog-passport-thumbnail.jpeg" width="98" height="123" alt="$whoname" />
        </td>
EOS;
    $colwidth = "60";
  }
  else
    $colwidth = "65";
  print <<< EOS

        <td align="center" width="$colwidth%">
          <table summary="title">
            <tr>
              <td align="center">
                <font size="6">
                  <b>$title</b>
                </font>
              </td>
            </tr>

EOS;
  if (isset ($subtitle))
    print <<< EOS
             <tr>
              <td align="center">
                 <font size="5">
                   <b>$subtitle</b>
                 </font>
              </td>
            </tr>

EOS;
  print <<< EOS
          </table>
        </td>

EOS;
  rightmenu ();                                 /* do the right-hand side and close the table */
}

function pageheader ($title)
{
  global $who;
  global $whoname;

  pageheader0 ( <<< EOS
<a href="/$who/index.php">$whoname</a>'s $title
EOS
);  /* ' */
}

/*
 * Output footer code.
 * $id is the RCS Id for displaying in the footer.
 * $extras, if present, are additional links to display in the summary line at
 * the bottom.  This line is severely limited in size, so be careful.
 */
function pagefooter ($id                                         /* , $extras */)
{
  global $who;
  global $whoname;

  $linkinfo = "/$who/index.php $whoname's home page\n";
  if ($who == "grog")
    $linkinfo .= "/grog/diary.php $whoname's diary\n";
  else if ($who == "yvonne")
    $linkinfo .= "/yvonne/training-diary.php Yvonne's training diary\n";
  $linkinfo .= "/$who/photos/photos.php $whoname's photos\n";
  if (func_num_args () > 1)                     /* $extras supplied */
    $linkinfo .= func_get_arg (1);              /* put them in linkinfo */
  $linkinfo .= "/grog/copyright.php Copyright\n";

  $links = explode ("\n", $linkinfo);

  belazy ();

print <<< EOS
  <!-- ====== Footings ================================================================== -->
    <hr />

    <table summary="footings" width="100%">
      <tr>
EOS;
  foreach ($links as $link)
  {
    if (preg_match ("|([^ ]+) (.+)|", trim ($link), $parts))
      print '    <td width="20%"><a href="' . $parts [1] . '">' . $parts [2] . "</a></td>\n";
  }
  print <<< EOS
      </tr>
    </table>

    <p>
    <a href="/grog/valid-xhtml.php">
<!--    <a href="http://validator.w3.org/check/referer"> -->
    <img src="http://www.w3.org/Icons/valid-xhtml10" alt="Valid XHTML 1.0!" height="31"
    width="88" /></a>
    </p>

    <center>
      <font size="-1">$id</font>
    </center>
  </body>
</html>
EOS;
}

/*
 * Generate the title information for the page.
 *
 * This used to take a month name as parameter, but now it computes it.
 */
function diary_title ()
{
  global $monthinfo;
  global $monthabbr;
  global $year;
  global $whoname;
  global $diary_complete;                       /* is this a complete month's diary? */

  $filename = basename ($_SERVER ["SCRIPT_FILENAME"]);
  if (preg_match ("|diary-(...)([12][0-9][0-9][0-9]).*|", $filename, $parts))
  {
    $monthabbr = $parts [1];
    $year = $parts [2];
    $month = $monthinfo [$monthabbr] ["Name"] . " " . $year;
    if ($year < 2000)
      $diary_complete = 0;                      /* XXX we don't have many complete months before 2000 */
  }
  print <<< EOS

    <meta name="description" content="$whoname Lehey's online diary" />
    <meta name="keywords" content="diary, Lehey" />
    <meta name="pinterest" content="nopin" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
EOS;
  javaheader ();
  print <<< EOS
    <title>$whoname&apos;s diary--$month</title>

EOS;
}

/*
 * Print a diary header.
 *
 * Optional parameter is a path to a photos to put at the top left.  This should
 * no longer be used directly; use monthly_diary_header instead.
 */

function diary_header (/* $photo */)
{
  global $lastmonth;
  global $nextmonth;
  global $monthinfo;
  global $isdiary;
  global $whoname;
  global $topics;
  global $topicnames;
  global $havetopics;                           /* set in calling page */

  $isdiary = 2;                                 /*  diary-specific stuff in rightmenu, with month */

  if (func_num_args () > 0)
    $photo = func_get_arg (0);
  else
    $photo = 'src="/grog/grog-passport-thumbnail.jpeg" width="98" height="123"';

  $filename = basename ($_SERVER ["SCRIPT_FILENAME"]);
  if (preg_match ("|diary-(...)([12][0-9][0-9][0-9]).*|", $filename, $parts))
  {
    $monthabbr = $parts [1];
    $year = $parts [2];
    $month = $monthinfo [$monthabbr] ["Name"] . " " . $year;
    if ($monthabbr == "jan")
      $year--;                                  /* previous year for previous month */
    $lastmonth = "diary-" . $monthinfo [$monthabbr] ["prev"] . $year . ".php";
    if (($monthabbr == "jan") || ($monthabbr == "dec"))
      $year++;                                  /* next year for next month */
    $nextmonth = "diary-" . $monthinfo [$monthabbr] ["next"] . $year . ".php";
  }
  print <<< EOS
    <table summary="heading" width="100%">
      <tr>

EOS;
  leftheader ($photo);

  print <<< EOS

        <td align="center" width="40%">
          <table summary="title">
            <tr>
              <td align="center"><a href="index.php">
                <font size="6">
                  <b><a href="index.php">$whoname</a>'s diary</b>
                </font></a>
              </td>
            </tr>

            <tr>
              <td align="center"><font size="6"><b>$month</b></font></td>
            </tr>
          </table>
        </td>
EOS;
  $rightmenu = <<< EOS
diary.php Today's diary entry
diary-about.php#index Diary index
diary-about.php About this diary

EOS;
  if ($topics != "")
    $topiclink = "?topics=$topics";
  else
    $topiclink = "";
  if (file_exists ($lastmonth))
    $rightmenu .= "$lastmonth$topiclink Previous month\n";
  if (file_exists ($nextmonth))
    $rightmenu .= "$nextmonth$topiclink Next month\n";
  $rightmenu .= <<< EOS
/grog/index.php $whoname's home page
/grog/photos/photos.php $whoname's photos
/grog/3gstats.php Network link stats
/grog/grogslinks.html $whoname's other links
/grog/copyright.php Copyright information

EOS;
  rightmenu ($rightmenu);
  if ($topics != "")
  {
    $ontopics = topicstring ($topics);
    print <<< EOS

      <blockquote>
        <i>
          This view of the diary is limited to these topics: $ontopics.  There may be lack of
          continuity in the text, and some days may be completely missing.  In case of doubt, please
          enable the complete display.
        </i>
      </blockquote>
EOS;
    if (0)
    {
    print "<pre>             XXX
";
    print_r ($_SERVER);
    print_r ($_REQUEST);
    print_r ($_GET);
    print_r ($_POST);
    print "</pre>
";
    }

  }
}

/*
 * Header for monthly diary files.
 */
function monthly_diary_header (/* $photo */)
{
  global $isrss;                                                                            /* set if we're outputting RSS 2.0 stuff */
  global $diary_complete;                       /* should be a complete diary, no gaps */
  global $topics;

  if (func_num_args () > 0)
    $photo = func_get_arg (0);
  else
    $photo = 'src="/grog/grog-passport-thumbnail.jpeg" width="98" height="123"';
  if ($topics != "")
    $diary_complete = 0;                        /* we're not complete if we have topics set */
  else
    $diary_complete = 1;
  $isrss = substr ($_SERVER ["SCRIPT_NAME"], -8, 8) == ".xml.php";

  if ($isrss)
  {
    if ($topics == "")
      $topicstr = "";
    else
      $topicstr = "?topics=$topics";
    /* Publication date is the modification timestamp of the script file */
    $stat = stat ($_SERVER ["SCRIPT_FILENAME"]);
    $ModDate = date ("c", $stat ["mtime"]);

    header('Content-type: application/rss+xml; charset=utf-8');
    print <<< EOS
<?xml version='1.0' encoding='UTF-8' ?>
<rss version="2.0"
      xmlns:atom="http://www.w3.org/2005/Atom"
      xmlns:dc="http://purl.org/dc/elements/1.1/"
      xmlns:sy="http://purl.org/rss/1.0/modules/syndication/">

<channel>
  <title>Greg's diary</title>
  <link>http://www.lemis.com/grog/diary.php</link>
  <atom:link href="http://www.lemis.com/grog/diary.xml.php$topicstr"
  rel="self" type="application/rss+xml" />
  <description>Greg Lehey's online diary</description>
  <dc:creator />
  <dc:date>$ModDate</dc:date>
  <dc:rights>Copyright 2011 Greg Lehey</dc:rights>

EOS;
  }
  else                                          /* normal HTML */
  {
    print <<< EOS
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html lang="en" xmlns="http://www.w3.org/1999/xhtml">
  <head>

EOS;
    diary_title ();                             /* just the title */
    print <<< EOS

EOS;
    include "css.php";
    print <<< EOS
  </head>
  <body>

EOS;
    javaincludes ();
    diary_header ($photo);                      /* most of the headers, including menus */
    print <<< EOS

    <div align="justify">

EOS;
    /* Add class="hyphenate" above */
  }
}

/*
 * Print a header for a single day.  This is primarily intended for diaries.
 *
 * shortdaytitle is a shorter version which only links to photos, previous and
 * next.
 *
 * $date is the date in format YYYYMMDD (at least at the moment).
 * $location is a location or series of locations to print in the second line.
 * $acmtitle is a special kludge for ACM queue.  Used only in RSS if topics = c,
 *           when it replaces the date.
 */
function daytitle ($date                                       /*, $location, $topics, $acmtitle */)
{
  global $who;
  global $firstday;                             /* first day entry on page */
  global $yesterday;                            /* day of previous title */
  global $lastday;                              /* set before the last entry on page */
  global $missing_days;                         /* list of any missing days */
  global $isdiary;                              /* diary without associated month */
  global $seen_lastday;                         /* set when we see a set $lastday */
  global $isrss;                                /* set if this is an RSS feed */
  global $servername;                           /* name of server, with http:// */
  global $daytopics;                            /* topics handled today */
  global $topics;                               /* and topics selected by user */
  global $daytopics;                            /* topics for today */
  global $diarydate;                            /* date of this entry */
  global $tomorrow;                             /* last forward link date */
  global $diary_complete;                       /* should be a complete diary, no gaps */
  global $current_topic;                        /* save topic string for later */
  global $missing_topics;                       /* list of undeclared topics */
  global $monthabbr;
  global $defaultsize;
  global $acmtitle;                             /* kludge header for ACM Queue */
  global $itemseq;                              /* sequence number of entry */
  global $homedir;                              /* UNIX home directory */
  global $day;                                  /* numerical value of day */

  /*
   * Horrible hack for Callum Gibson.  Make the items start on the following day
   * AEST.  This doesn't really address the issue, but it may make things
   * marginally better.
   *
   * 20100711: XXX Revert $itemseq as part of pubDate.  It doesn't seem to help,
   * and it stuffs things up right royally if I add anything after publication.
   */
  if ($date > "20100602")                       /* XXX do this to avoid resequencing "old" stuff */
    $itemseq = -1;                              /* increment get hours for pubDate */
  else
    $itemseq = 9;                               /* increment get hours for pubDate */
  if (func_num_args () > 3)                     /* we have an alternate title  */
    $acmtitle = func_get_arg (3);
  if (($firstday == 0) && (array_key_exists ("dirdate", $_GET)))
    {
      $dirdate = $_GET ["dirdate"];

    /*
     * XXX This means well, but doesn't currently work.
     */
      if (0 && ($isdiary == 1) && ($dirdate < $date)) /* old entry in today's diary */
      {
        $dirtm = validdate ($dirdate, "date");
        $diarydate = formatdate ("l, j F Y", $dirtm);
        $diaryurl = "diary-" . $monthabbr [$dirtm ["mon"]] . $dirtm ["year"] . ".php#" . $dirtm ["mday"];

        print <<< EOS
<p>
        <font color="red">
          The URL you supplied contains a reference to the entry for $diarydate,
	  which is no longer present in this diary of recent events.  Would you like
	  to <a href="$diaryurl">read the old entry</a>?
	</font>
      </p>

EOS;
      }
    }
  if ($missing_topics != "")                    /* missing topics for previous day? */
  {
    $missing_days .= "Missing topics for $diarydate: $missing_topics\n";
    $missing_topics = "";
  }
  check_no_topic ();                            /* Make sure we closed the last topic */
  /* No default location */
  if (func_num_args () > 1)
    $location = func_get_arg (1);
  else
    $location = "";
  $diarydate = $date;                           /* save for error messages */

  /* Get topics, by default all of them */
  if (func_num_args () > 2)
    $daytopics = func_get_arg (2);
  else
    /*
     * Use the topic list to check that what we claim is correct.
     */
    $daytopics = "";

  /* Get some information */
  $photodir = "$homedir/Photos/$date";
  $photodate = validdate ($date, "date");
  $day = formatdate ("j", $photodate);

  if (is_string ($photodate))
    /*
     * Wrong date.  We shouldn't really print this in the RSS/XML case, but it's
     * an error message anyway and shouldn't get out of my office.
     */
    print ('          <p>'
           . '          <font color="red" size="+2">Invalid date in title: '
           . "$photodate $date</font>
           '          <p>");
  else                                          /* valid date */
  {
    $realdate = formatdate ("l, j F Y", $photodate);
    if ($lastday)
    {
      if ($seen_lastday)
        $missing_days .= "Duplicate last day $seen_lastday\n";
      $seen_lastday = $day;
    }
    if (! $isrss)                               /* HTML */
    {
      print <<< EOS
<!-- ==== $realdate ==== -->
EOS;
    }
    if (! $isrss)
    {
      /*
       * $tomorrow was set "yesterday", but if we've skipped a day, it won't be
       * pointing at today.  Create a second tag for it.  We still need the real
       * one below for the backwards link.  We don't do this for the first
       * entry, obviously.
       */
      if (($day != $tomorrow) && ($tomorrow))
        print <<< EOS

      <a name="$tomorrow"></a>     <!-- skipped days -->
EOS;
      if (! on_topic ($daytopics, $topics))     /* no interesting topics? */
      {
        $yesterday = $day;                      /* note where we are, */
        $firstday = $day;                       /* XXX foo */
        return;                                 /* and give up */
      }
      /* Header components for HTML */
      print <<< EOS

      <br />

EOS;
      if ($lastday)
        print <<< EOS
      <a id="bottom" name="bottom" />

EOS;
      print <<< EOS
      <a name="$day"></a>
        <table width="100%" summary="Day heading">
          <tr>
            <td width="40%"><font size="+2"><b>$realdate</b></font></td>
            <td width="30%" align="center"><i>$location</i></td>
            <td width="30%" align="right">
EOS;

      if (file_exists ($photodir))
      {
        $mydate = formatdate ("j F Y", $photodate);
        print "
              <a href=\"$servername/$who/photos/Photos.php?dirdate=$date\">
                Images for $mydate
              </a>
            ";
      }
      print "</td>
          </tr>
";
      if ($who == "grog")                       /* Yvonne doesn't do every day */
      {
        $me = $_SERVER["PHP_SELF"];
        if ($topics != "")
          $me .= "?topics=$topics";
        /* Link to various places */
        print <<< EOS
          <!-- navigation links -->
          <tr><td></td><td></td><td align="right"><a href="$me">Top of page</a></td></tr>

EOS;
        if ($firstday)
        {
          if (($yesterday != ($day - 1))
              && (($day != 1) || ($isdiary < 2)) /* don't complain on diary wraparound */
              && $diary_complete )              /* and the diary is supposed to be complete */
            $missing_days .= "incorrect sequence: $yesterday followed by $day\n";
          print <<< EOS
          <tr><td></td><td></td><td align="right"><a href="$me#$yesterday">previous day</a></td></tr>

EOS;
          $yesterday = $day;
        }
        else                                    /* we're the first day */
        {
          $firstday = $day;
          $yesterday = $day;
          if (($day > 1) && ($isdiary == 2) && $diary_complete) /* full monthly diary, missing start */
            $missing_days .= "File starts at day $day\n";
        }
        if (! $lastday)
        {
          $tomorrow = $day + 1;
        print <<< EOS
          <tr><td></td><td></td><td align="right"><a href="$me#$tomorrow">next day</a></td></tr>
          <tr><td></td><td></td><td align="right"><a href="$me#bottom">last day</a></td></tr>

EOS;
        }
      }
      print <<<EOS

          <!-- end of navigation links -->
        </table>

EOS;
    }
  }
}

/*
 * Header for other purposes than diary.  Links to diary when it exists.
 */
function dayheader ($date                                       /*, $anchor */)
{
  global $who;

  if (func_num_args () > 1)
    $anchor = func_get_arg (1);
  else
    $anchor = $date;
  print <<< EOS
<p />
      <a name="$anchor" id="$anchor" />

EOS;
  $photodate = validdate ($date, "date");
  if (is_string ($photodate))
    /*
     * Wrong date.  We shouldn't really print this in the RSS/XML case, but it's
     * an error message anyway and shouldn't get out of my office.
     */
    print ('          <p>'
           . '          <font color="red" size="+2">Invalid date in title: '
           . "$photodate $date</font>
           '          <p>");
  else                                          /* valid date */
  {
    $realdate = formatdate ("l, j F Y", $photodate);
    print <<< EOS
        <table width="100%" summary="Day heading">
          <tr>
            <td width="40%"><font size="+2"><b>$realdate</b></font></td>
            <td width="30%" align="center"><i></i></td>
            <td width="30%" align="right">
EOS;
    $day = formatdate ("j", $photodate);
    $month = strtolower (formatdate ("M", $photodate));
    $year = formatdate ("Y", $photodate);
    $realdate = formatdate ("l, j F Y", $photodate);
    /* File and URL of corresponding diary entry */
    $diary = "/$who/diary-$month$year";
/*    if (file_exists ("$diary.php")) */
      print '<a href="'.  "$diary.php#$day" .  '">Diary entry</a>';
    print "</td>
      </tr>
    </table>";
  }
}

function diary_footer ($lastmonth, $nextmonth, $id)
{
  global $whoname;
  global $isrss;                                /* set if RSS */
  global $lastday;
  global $missing_days;
  global $missing_topics;
  global $diarydate;
  global $topics;
  global $me;

  if ($isrss)
  {
    print <<< EOS
</channel>
</rss>

EOS;
  }
  else
  {
    if ($lastday == 0)                          /* no last day specified, so no #bottom tag */
      {
      print <<< EOS
      <a name="bottom" id="bottom" />

EOS;
      }
    if ($missing_topics != "")
    {
      $missing_days .= "Missing topics for $diarydate: $missing_topics\n";
      $missing_topics = "";
    }
    if ($missing_days != "")
    {
      $host = $_SERVER ["REMOTE_HOST"];
      $hostaddr = $_SERVER["REMOTE_ADDR"];
      mail ($_SERVER ["SERVER_ADMIN"],
             "Invalid entries in diary " . $_SERVER ["REQUEST_URI"],
             $missing_days
             . "\nClient: $host ($hostaddr)");
    }
    belazy ();
    print <<< EOS
</div>

    <!-- ====== Footings ================================================================== -->
    <hr />

    <table summary="footings" width="100%">
      <tr>
        <td align="center" width="16%"><a href="$me">Top of page</a></td>

EOS;
    if ($topics != "")
      $topiclink = "?topics=$topics";
    else
      $topiclink = "";
  if (file_exists ($lastmonth))
    print '
        <td align="center" width="16%"><a href="' . $lastmonth . $topiclink . '">Previous month</a></td>';
  print '
        <td align="center" width="16%"><a href="index.php">' . $whoname . '\'s home page</a></td>
        <td align="center" width="16%"><a href="diary.php' . $topiclink . '">Today\'s diary entry</a></td>';
  if (file_exists ($nextmonth))
    print '
        <td align="center" width="16%"><a href="' . $nextmonth . $topiclink . '">Next month</a></td>';
    print <<< EOS
        <td align="center" width="16%"><a href="photos/photos.php">$whoname's photos</a></td>
        <td align="center" width="16%"><a href="/grog/copyright.php">Copyright information</a></td>
      </tr>
    </table>

    <p>
    <a href="/grog/valid-xhtml.php">
<!--    <a href="http://validator.w3.org/check/referer"> -->
    <img src="http://www.w3.org/Icons/valid-xhtml10" alt="Valid XHTML 1.0!" height="31"
    width="88" /></a>
    </p>

    <center>
      <font size="-1">$id</font>
    </center>
  </body>
</html>

EOS;
  }
}

/*
 * Show a header for the "recent days" diary.
 */
function todays_diary_header ($thismonth)
{
  global $rightmenu;
  global $who;
  global $whoname;
  global $isdiary;
  global $topics;
  global $diary_complete;

  $diary_complete = 0;                          /* we can have gaps in this diary */
  $isdiary = 1;                                 /* diary without associated month */
  if ($who == "grog")
    $photo = 'src="/grog/grog-passport-thumbnail.jpeg" width="98" height="123"';
  else if ($who == "yvonne")
    $photo = 'src="/yvonne/Photos/20061226/tiny/yessss.jpeg"';
  else                                          /* XXX find something funny for this! */
    $photo = 'src="/grog/grog-passport-thumbnail.jpeg" width="98" height="123"';
    javaincludes ();
  print <<< EOS
<table summary="heading" width="100%">
      <tr>

EOS;
  leftheader ($photo);
  print '
        <td align="center" width="40%">
          <table summary="title">
            <tr>
              <td align="center"><font size="6"><b><a href="index.php">' . $whoname . '</a>\'s diary</b></font>
              </td>
            </tr>

            <tr>
              <td align="center"><font size="6"><b>Recent entries</b></font> </td>
            </tr>
          </table>
        </td>
';
   if ($who == "grog")
     {
       if ($topics == "")
         $rightmenu = "diary-$thismonth.php This month's diary\n";
       else
         $rightmenu = "diary-$thismonth.php?topics=$topics This month's diary\n";
     if (islocal ())                            /* do locally only */
        $rightmenu .= "diary-tomorrow.php Tomorrow's diary\n";
      $rightmenu .= <<< EOS
blog.html $whoname's blog
diary-about.php#index Diary index
diary-about.php About this diary
/$who/photos/photos.php $whoname's photos
/$who/index.php $whoname's home page
/grog/3gstats.php Network link stats
/$who/grogslinks.html $whoname's other links
/$who/copyright.php Copyright information

EOS;
    }
  else if ($who == "yvonne")
    {
     $rightmenu .= <<< EOS
/yvonne/photos/photos.php Yvonne's photos
/yvonne/index.html Yvonne's home page
/yvonne/art/ Cavall'art: Yvonne's art pages

EOS;
    }
  rightmenu ($rightmenu);
}

function todays_diary_footer ($lastmonth, $thismonth)
{
  global $whoname;
  global $lastday;
  global $missing_days;

  if ($lastday == 0)                            /* no last day specified, so no #bottom tag */
    print <<< EOS
      <a name="bottom" id="bottom">

EOS;
  if ($missing_days != "")
    mail ($_SERVER ["SERVER_ADMIN"],
          "Invalid entries in diary " . $_SERVER ["REQUEST_URI"],
          $missing_days );
  $mytopics = topicref ();
  $lastmonth_file = "diary-$lastmonth.php";
  print <<< EOS
    <hr />

    <div align="justify">
      <table>
        <tr>
	  <td>
          <i>This page contains (roughly) yesterday's and today's entries.  I have
            a <a href="Rant/reverse-horror.html">horror of reverse chronological documents</a>, so
            all my diary entries are chronological.  I try to leave the pages here for two days;
            you'll find them all in the <a href="diary-about.php#index">archive</a>, so if I fall
            behind a day or two, you may find more here.  Note that I often update a diary entry a
            day or two after I write it.</i>
	  </td>

	  <td width="5%">
	  </td>

	  <td>
          <i>
            Do you have a comment about something I have written?  This is a diary, not a
	    &ldquo;blog&rdquo;, and there is deliberately no provision for directly adding comments.
	    But I welcome feedback and try to reply to all messages I receive.  See
	    the <a href="diary-about.php">diary overview</a> for more details.  If you do send me a
	    message relating to something I have written, please indicate whether you'd prefer me
	    not to mention your name.  Otherwise I'll assume that it's OK to do so.
	  </i>
	  </td>
        </tr>
      </table>
    </div>
EOS;

     belazy ();

print <<< EOS
    <p>
    <!-- ====== Footings ================================================================== -->
   </p>
    <hr />

    <table summary="footings" width="100%">
      <tr>
EOS;
if (file_exists ($lastmonth_file))
  print '        <td align="center" width="20%"><a href="' .  $lastmonth_file . '#bottom">Previous month</a> </td>
';
print <<< EOS
        <td align="center" width="20%"><a href="index.php">$whoname's home page</a> </td>
        <td align="center" width="20%"><a href="diary-$thismonth.php$mytopics">This month</a></td>
        <td align="center" width="20%"><a href="photos/photos.php">$whoname's photos</a> </td>
        <td align="center" width="20%"><a href="/grog/grogslinks.html">$whoname's links</a> </td>
      </tr>
    </table>

    <br />

    <table summary="more stuff" width="50%">
      <tr>
        <td><a href="diary.xml.php$mytopics" title="XML Feed (RSS 2.0)" target='_blank'><span
        style="background-color: #ff6600;"><font color="white">RSS</font></span> 2.0</a> </td>
            <td><a href="/grog/valid-xhtml.php">
<!--        <td><a href="http://validator.w3.org/check/referer"> -->
         <img src="http://www.w3.org/Icons/valid-xhtml10" alt="Valid XHTML 1.0!" height="31"
        width="88" /></a> </td>
      </tr>
    </table>

EOS;
}

/*
 * Create a link to a diary event.  This takes two parameters.  The second
 * parameter is an optional text to put in the link; it defaults to the date.
 */
function diaryref ($date                                                                           /*, $opttext */)
{
  global $servername;                           /* name of server, with http:// */

  $mytopics = topicref ();
  $mydate = validdate ($date, "date");
  $day = formatdate ("j", $mydate);
  $month = strtolower (formatdate ("M", $mydate));
  $year = formatdate ("Y", $mydate);

  /* Default to date */
  $text = "";
  if (func_num_args () > 1)
    $text = func_get_arg (1);
  if ($text == "")
    $text = formatdate ("j F Y", $mydate);

  print "<a href=\"$servername/grog/diary-$month$year.php$mytopics#$day\">$text</a>";
}

/*
 * Alternative version of diaryref where a specific tag exists.
 * The day part of the date must be valid, but it isn't used.
 * The third parameter is an optional text.
 */
function diarytag ($date, $tag                                                                                                       /*, $opttext */)
{
  global $servername;                           /* name of server, with http:// */

  $mytopics = topicref ();
  $mydate = validdate ($date, "date");

  $month = strtolower (formatdate ("M", $mydate));
  $year = formatdate ("Y", $mydate);
  $text = "";                                   /* to handle empty strings */

  /* Default to date */
  if (func_num_args () > 2)
    $text = func_get_arg (2);
  if ($text == "")
    $text = formatdate ("j F Y", $mydate);
  print "<a href=\"$servername/grog/diary-$month$year.php$mytopics#$tag\">$text</a>";
}

function h2 ($left, $center, $right)
{
print <<< EOS
        <table width="100%" summary="heading">
          <tr>
            <td width="40%"><font size="+2"><b>$left</b></font></td>
            <td width="30%" align="center"><i>$center</i></td>
            <td width="30%" align="right">
              $right
            </td>
          </tr>
        </table>
EOS;
}

/*
 * Print a header for a single day.  This is a shorter version of daytitle which
 * only links to photos, previous and next.
 *
 * $date is the date in format YYYYMMDD (at least at the moment).
 */
function shortdaytitle ($date)
{
  global $servername;                           /* name of server, with http:// */
  global $diarydate;                            /* date of this entry */
  global $lastday;                              /* this is the last day on page */
  global $monthabbr;
  global $title_number;                         /* number of title, for links */
  global $defaultsize;
  global $who;                                  /* user ID */
  global $me;
  global $homedir;

  /* Get some information */
  $photodir = "$homedir/Photos/$date";
  $photodate = validdate ($date, "date");
  $realdate = formatdate ("l, j F Y", $photodate);
  $day = formatdate ("j", $photodate);
  $diary = "/$who/diary-" . $monthabbr [substr ($date, 4, 2)]
           . substr ($date, 0, 4)
           . ".php#";
  if (substr ($date, 6, 1) == "0")
    $diary .= substr ($date, 7, 1);
  else
    $diary .= substr ($date, 6, 2);

  if (is_string ($photodate))
    /*
     * Wrong date.  We shouldn't really print this in the RSS/XML case, but it's
     * an error message anyway and shouldn't get out of my office.
     */
    print ('          <p>'
           . '          <font color="red" size="+2">Invalid date in title: '
           . "$photodate $date</font>
           '          <p>");
  else                                          /* valid date */
  {
    $last_title_number = $title_number;         /* previous header */
    $title_number++;
    print <<< EOS
<!-- ==== $realdate ==== -->
EOS;
    /* Header components for HTML */
    print <<< EOS

      <br />

EOS;
    if ($lastday)
      print <<< EOS
      <a id="bottom" name="bottom" />

EOS;
    print <<< EOS
      <a name="$title_number"></a>
        <table width="100%" summary="Day heading">
          <tr>
            <td width="40%"><font size="+2"><b>$realdate</b></font></td>
            <td width="10%" align="right"><a href="$diary">Today&#39;s diary</a></td>
            <td width="10%" align="right">
EOS;

    if (file_exists ($photodir))
    {
      $mydate = formatdate ("j F Y", $photodate);
      print "
              <a href=\"$servername/$who/photos/Photos.php?dirdate=$date\">
                Today's images
              </a>
            ";
    }
    /* Link to various places */
    print <<< EOS
          </td>
          <!-- navigation links -->
          <td width="5%" align="right"><a href="$me">top</a>
          <td width="5%" align="right">
EOS;
    if ($last_title_number)                     /* we have a previous header */
      print "<a href=\"$me#$last_title_number\">previous</a>"; /* link to it */
    print "</td>\n";
    if (! $lastday)
    {
      $next = $title_number + 1;
      print <<< EOS
          <td width="5%" align="right"><a href="$me#$next">next</a></td>
          <td width="5%" align="right"><a href="$me#bottom">last</a></td>

EOS;
    }
    else                                        /* leave space */
      print <<< EOS
          <td width="10%" ></td>

EOS;

  }
  print <<<EOS

          <!-- end of navigation links -->
        </table>

EOS;
}

/*
 * Short day header.  Just print the date bold with a link to diary entry.
 * $tag, if present, is a substitute tag for the diary link.
 */
function dayhdr ($date                          /*, $tag */)
{
  global $homedir;
  global $who;

  $date = validdate ($date, "date");
  $realdate = formatdate ("l, j F Y", $date);
  if (func_num_args () > 1)
    $tag = func_get_arg (1);                    /* supplied tag */
  else
    $tag = formatdate ("j", $date);             /* default to day */
  $month = strtolower (formatdate ("M", $date));
  $year = formatdate ("Y", $date);
  $diary = "diary-$month$year.php";

  if (file_exists ("$homedir/$diary"))
  print <<< EOS
      <h3><a href="/$who/$diary#$tag">$realdate</a></h3>

EOS;
  else
  print <<< EOS
      <h3>$realdate</h3>
EOS;
}

function h2link ($left, $center, $url, $text)
{
print <<< EOS
        <table width="100%" summary="heading">
          <tr>
            <td width="40%"><font size="+2"><b>$left</b></font></td>
            <td width="30%" align="center"><i>$center</i></td>
            <td width="30%" align="right">
EOS;
  href ($url, $text);
print <<< EOS
            </td>
          </tr>
        </table>
EOS;
}

function h3link ($left, $center, $url, $text)
{
print <<< EOS
        <table width="100%" summary="heading">
          <tr>
            <td width="40%"><font size="+1"><b>$left</b></font></td>
            <td width="30%" align="center"><i>$center</i></td>
            <td width="30%" align="right">
EOS;
  href ($url, $text);
print <<< EOS
            </td>
          </tr>
        </table>
EOS;
}

/*
 * texttopic, endtopic: Only display the text in between if the topic letter is
 * set in the string $topics.
 *
 * Second parameter is an h3 title if used.
 */
function texttopic ($topic                                                 /*, $title, $anchor */)
{
  global $topics;
  global $offtopic;                             /* set if we're not processing this topic */
  global $missing_days;                         /* consistency error messages */
  global $daytopics;                            /* topics for today */
  global $diarydate;                            /* date of this entry */
  global $isrss;                                /* are we doing an RSS document? */
  global $current_topic;                        /* save topic string for later */
  global $acmtitle;                             /* kludge header for ACM Queue */
  global $servername;                           /* name of server, with http:// */
  global $itemseq;                              /* sequence number of entry */
  global $PubDate;                              /* publication date for RSS */
  global $me;                                   /* my name */
  global $day;                                  /* numerical value of day */
  global $anchorlink;                           /* name of current diary file and anchor */
  global $myurl;                                /* URL of this page */
  global $origlink;

  /*
   * $itemseq is the sequence of the topic in the day.  We count it even if we
   * don't use it
   */
  $itemseq++;
  /*
   * Sequence of the topic in the day.  This is 2 digits to make RSS happy.
   */
  $seq = sprintf ("%02d", $itemseq);            /* to ensure 2 digits */
  $mydate = validdate ($diarydate, "date");
  $realdate = formatdate ("l, j F Y", $mydate);
  /*
   * Make up an anchor out of $day and $seq.  We do this even if an anchor is
   * specified in the parameters, since it might not always have been there.
   * The anchor in the parameters is always in addition to the generated anchor.
   */
  if ($PubDate < "2011-12-05")
    $myanchor = "D$day-$itemseq";
  else
  {
    /*
     *  $PubDate isn't set for older entries, but it's guaranteed to be set
     *  here.
     */
    $myanchor = "D" . preg_replace ("/(....)-(..)-(..)T(..):(..):(..).*/",
                                    "-\\1\\2\\3-\\4\\5\\6",
                                    $PubDate );
  }
  if (func_num_args () > 2)
    $anchor = func_get_arg (2);
  else
    $anchor = "";                               /* no anchor for this header */
  check_no_topic ();
  $current_topic = $topic;                      /* note current topic */
  check_registration ();
  if (on_topic ($topic, $topics))
  {
    $mytopics = topicstring ($topic);
    /* We're already indented at this point */

    $day = formatdate ("j", $mydate);
    $month = strtolower (formatdate ("M", $mydate));
    $year = formatdate ("Y", $mydate);
    if ($topics != "")
      $topiclink = "?topics=$topics";
    else
      $topiclink = "";
    if (($topics == "c") && ($acmtitle != ""))  /* we have an alternate title  */
      $dayheader = $acmtitle;
    else
      $dayheader = $realdate;

    if (func_num_args () > 1)                   /* we have a title  */
      $title = func_get_arg (1);

    /* This is a left-over from older code which set the title in daytitle ().  Die!  Die! */
    else if (("$acmtitle" != "") && on_topic ($topic, "c"))
    {
      $title = $acmtitle;
      $acmtitle = "";                           /* only use once */
    }
    else
      $title = "";

    if ($isrss)
    {
      /* We have a title per topic for RSS.  Use date in case of doubt. */
      if ($title == "")
        $title = /* $pubdate . ": */ "$mytopics";

      $myurl = "diary-$month$year.php";

      /*
       * What a pain!  I've made not one, but two messes with the anchor in the
       * isPermaLink, and I can fix it.  But since it's permanent, I can't do it
       * retrospectively.  Ugh.
       */
      if ($diarydate > "20110700")
        $anchorlink = "$myurl#$myanchor";
      else
        $anchorlink = "$myurl#$day$myanchor";
      $origlink = "$servername/grog/diary-$month$year.php$topiclink#$myanchor";

print <<< EOS

<item>
  <guid isPermaLink='true'>$servername/grog/$anchorlink</guid>
  <link>$origlink</link>

EOS;

  /* Add categories */
      $categories = explode (" ", preg_replace ("|,|", "", $mytopics));
      foreach ($categories as $category)
        print <<< EOS
  <category>$category</category>

EOS;
      /*
       * Older entries don't use PubDate, so we concoct a pubDate string and
       * enter it here.  Newer entries put this in at the end (because the
       * example I've seen does) so it happens in endtopic ().
       */
      if ($PubDate == "")                       /* no PubDate specified */
      {
        $pubdate = formatdate ("D, j M Y", $mydate) . " 23:59:00 +0000";
      print <<< EOS
  <title>$title</title>
    <pubDate>$pubdate</pubDate>
    <description>
      <![CDATA[
      <div align="justify">

EOS;
      }
      else
        print <<< EOS
  <title>$title</title>
    <description>
      <![CDATA[
      <div align="justify">

EOS;
      }
    else                                        /* not RSS */
    {
      if ($topics != "")
        $topiclink = "?topics=$topics";
      else
        $topiclink = "";
      /*
       * Already indented too far here, so add an empty line.  The <br /> is
       * needed to stop firefox from locating the anchor in the wrong place.
       */
      print <<< EOS

      <br />
      <a name="$myanchor" id="$myanchor" />

EOS;
      /*
       * We have a problem with anchors here.  I allocate mnemonic names for the
       * ones I care about, but the automatically generated one still needs to
       * be there for the case that somebody has remembered it.  But the one we
       * give as "Link here" should be the mnemonic one if it exists.
       */
      if ($anchor != "")
      {
        print <<< EOS
      <a name="$anchor" id="$anchor" />

EOS;
        $myanchor = $anchor;                    /* give this one as reference */
      }

      $origlink = "$servername/grog/diary-$month$year.php$topiclink#$myanchor";
      print <<< EOS
      <table class=".headerwidth" style="width: 70ex" width="100%">
        <tr>
          <td width="50%" valign="top" align="left">
            <div style="font-size:1.1em; font-weight:bolder">$title</div>
          </td>
          <td width="30%" align="center" valign="top">
            <i>Topic: $mytopics</i>
          </td>
          <td width="20%" align="right" valign="top">
            <a href="$origlink">Link here</a>
          </td>
        </tr>
      </table>

EOS;
    }
  }
  else                                          /* off topic, comment out */
  {
    $offtopic = 1;                              /* note for endcat */
    print <<< EOS

<!-- topic $topic not selected

EOS;
  }
}

function endtopic ()
{
  global $offtopic;
  global $current_topic;
  global $isrss;                                /* are we doing an RSS document? */
  global $PubDate;
  global $origlink;

  if ($offtopic)
  {
    $offtopic = 0;                              /* forget this one */
    print <<< EOS

 End deselected topic $current_topic -->

EOS;
  }
  else if ($isrss)
  {
    if (preg_match (":acm.com$:", $_SERVER ["SERVER_NAME"])) /* ACM crawler? */
      print <<< EOS
        <blockquote>
        <p>
	<i>ACM only downloads articles once.  It's possible that this article has changed since
	being downloaded, but the only way you can find out is by looking at
	the <a href="$origlink">original
	article</a>.</i>
      </p>
    </blockquote>

EOS;

    print <<< EOS
</div>
      ]]>
    </description>

EOS;
  if ($PubDate != "")
    print <<< EOS
    <dc:creator>Greg Lehey</dc:creator>
    <dc:date>$PubDate</dc:date>

EOS;
    print <<< EOS
</item>

EOS;
  }
  $current_topic = "";
}

/*
 * Check if any of $topics match $mytopics.  Return 1 if so, -1 if there are no
 * topics, 0 otherwise.
 */
function on_topic ($mytopics, $topics)
{
  if ($topics != "")
  {
    $numtopics = strlen ($topics);
    for ($i = 0; $i < $numtopics; $i++)
      if (strstr ($mytopics, $topics [$i]))     /* found a topic in common */
        return 1;
    return 0;
  }
  return -1;                                    /* default: no topics specified */
}

/*
 * Convert topic letters to a string.
 */
function topicstring ($topics)
{
  global $topicnames;

  $result = "";
  for ($i = 0; $i < strlen ($topics); $i++)
  {
    $thistopic = $topics [$i];
    if ($result != "")
      $result .= ", ";
    if (array_key_exists ($thistopic, $topicnames))
      $result .= $topicnames [$thistopic];
    else
      $result .= "<font color=\"red\">invalid topic abbreviation $thistopic</font>";
  }
  return $result;
}

/*
 * Return a string ?topics=$topics if $topics (global) is set.
 * Used to create diary references.
 * Note that the ? is included, so it needs to be the first parameter.
 */
function topicref ()
{
  global $topics;
  if ($topics != "")
    return "?topics=$topics";
  else
    return "";
}

/*
 * Check that we don't have a topic still open. */
function check_no_topic ()
{
  global $current_topic;
  global $missing_days;
  global $diarydate;

  if ($current_topic != "")
  {
    $missing_days .="Incomplete topic $current_topic on $diarydate\n";
    if ($_SERVER ["SERVER_NAME"] == "wwww.lemis.com")
    {
      print <<< EOS
      <p>
      <b><font color="red">Incomplete topic $current_topic</font></b>
      </p>
EOS;
    }
  }
}

/*
 * Check that the current topic has been declared in the day header, add to
 * $missing_topics if not.
 */
function check_registration ()
{
  global $current_topic;
  global $daytopics;
  global $missing_topics;

  {
    for ($i = 0; $i < strlen ($current_topic); $i++)
    {
      $onetopic = $current_topic [$i];
      if (((! on_topic ($onetopic, $daytopics))
           || ($daytopics == ""))
          && ((! on_topic ($onetopic, $missing_topics))
              || ($missing_topics == "") ) )
        $missing_topics .= $onetopic;
    }
  }
}

/*
 * Produce the script stuff in the head of a page.
 * Currently no parms.
 */
function javaheader ()
  {
  global $isrss;

  if (! $isrss)
    print <<< EOS

    <script type="text/javascript" src="/grog/js/tipmessage/main.js"></script>
    <script type="text/javascript" src="/grog/js/Hyphenator/Hyphenator.js"></script>
    <script type="text/javascript" src="/grog/js/photocompare.js"></script>
    <script type="text/javascript" src="/grog/js/jquery.js"></script>
    <script type="text/javascript" src="/grog/js/jquery.lazyload.js"></script>
    <script type="text/javascript">
      var _gaq = _gaq || [];
      _gaq.push(['_setAccount', 'UA-18219963-2']);
      _gaq.push(['_trackPageview']);

      (function() {
        var ga = document.createElement('script');
        ga.type = 'text/javascript'; ga.async = true;
        ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
        var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
  })();
   </script>

EOS;
  }

/*
 * Produce the script stuff at the start of a body.
 * Currently no parms.
 */
function javaincludes ()
  {
  global $isrss;

  if (! $isrss)
    /* We're expecting to be already indented when we print this */
    print <<< EOS
<div id="TipLayer" style="visibility:hidden;position:absolute;z-index:1000;"></div>
    <script type="text/javascript">
      Tipstyle = ["white",
                  "black",
                  "#000099",
                  "#E8E8FF",
                  "",
                  "",
                  "",
                  "",
                  /* These two don't seem to make any difference */
                  "Helvetica",                  /* Title font face */
                  "Helvetica",                  /* Text font face */
                  "5",                          /* position */
                  "2",                          /* StickyStyle */
                  "-1",
                  "7",
                  500,                          /* Width, in pixels */
                  "",
                  2,
                  2,
                  100,                          /* CoordinateX */
                  80,                           /* CoordinateY */
                  51,
                  1,
                  0,
                  "",
                  ""];
    var exif_info = [];
    </script>

EOS;
  }

/* Note publication date for RSS */
function pubdate ($date)
{
  global $PubDate;
  $PubDate = $date;
}

/* Initialize lazy load of images */
function belazy ()
{
    print <<< EOS
     <script type="text/javascript" charset="utf-8">
         $(function() {
             $("img.lazy").show().lazyload();
             $("img").lazyload();
         });
     </script>
EOS;
}

?>
